// #autoload
// #name = DEDEN Demo Advanced
// #version = 0.0.4
// #date = April 15, 2002
// #status = Beta II
// #description = Advanced demo features
// #author = ]S[DEDEN
// #warrior = DEDEN
// #email = warpath@strategyplanet.com
// #category = DEDEN Script
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs

// To do list:
// ! scaling interface for the demo browser.  Fixed by not scaling, just making it more compact. =)
// - improved some Sierra code to be more reliable and require less memory.
// - demo browsing by thumbnail (still very, very beta). Basically, you can set the script to auto-take screenshots at various points through when you're demoing. These screenshots are then used as thumbnails... You get a screenfull of images with a filename listed under them to look through... Double-click on one to play, or right-click and use the context menu to rename or delete.
// ! Remembers the last directory and demo played and re-selects those automatically once you stop a demo and come back to the lobby.
// - Key binds for demo playback.
// - full control of sequenced image output (for AVI/ MPGs). Switch on and off pretty much everything visible in the game. Want only triangles and health to show, untick everything else... want increased gamma, a different resolution, or something else, change it....
// ! Re-worked output interface. 
// - Pseudo-automatic conversion to DivX4.x. Once you've finished, double-click the batch file in your T2 dir to make a movie.
// - Batch conversion to sequenced images... Select a number of demos and times and set your machine to output them in one sitting. Switch off the screen, come back in the morning, double-click the batch file, come back sometime later and a whole lot of DivX movies are waiting for you.
// - console string error with taking snapshots


package DEDDemoAdvanced {
//------------------------------------------------------------------------------------------	
// Initialization, re-initialization, and debugging functions
//------------------------------------------------------------------------------------------
	// Quick re-compile and re-initialize for the script.  Note:  remove when finished.
	function DDA() {
		exec("scripts/autoexec/DEDDemoAdvanced_Beta.cs");
		DEDDemoAdvanced_ClearTimes();
		DEDDemoAdvanced.Setup();
	}


	// Initialize the script.
	function DEDDemoAdvanced::Setup(){
		// Create the Textures/Snapshots/ directory if it doesn't already exist.
		if (!isFile("Textures/Snapshots/")) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForWrite("Textures/Snapshots/");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		
		// Created the Sequenced Images/ directory if it doesn't already exist.
		if (!isFile("Sequenced Images/")) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForWrite("Sequenced Images/");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}

		$DemoFileSnapshot = "";

		// Set up the initial values for DEDDemoAdvanced variables.
		DEDDemoAdvanced.AlwaysRecordTournaments = 0;
		DEDDemoAdvanced.AutomaticSafetyMode = 0;
		DEDDemoAdvanced.BatchList = "";
		DEDDemoAdvanced.CurrentPath = "";
		DEDDemoAdvanced.DeleteSound = "DDA_None_Del";
		DEDDemoAdvanced.EnableAudioAlerts = 0;
		DEDDemoAdvanced.FPS = 30;
		DEDDemoAdvanced.GameType = 0;
		DEDDemoAdvanced.GameTypeDir = 0;
		DEDDemoAdvanced.GammaCorrection = $pref::OpenGL::gammaCorrection;
		DEDDemoAdvanced.LastDemoFileNumber = 0;
		DEDDemoAdvanced.LastDemoFileName = "";
		DEDDemoAdvanced.LastSelected = 0;
		DEDDemoAdvanced.HUDLocked = false;
		DEDDemoAdvanced.HUDPosRecordingHud = "42 25";
		DEDDemoAdvanced.MissionName = 0;
		DEDDemoAdvanced.MissionNameDir = 0;
		DEDDemoAdvanced.MovingHUD = false;
		DEDDemoAdvanced.NoSnapShotHUDs = 0;
		DEDDemoAdvanced.NumBatchList = 0;
		DEDDemoAdvanced.NumPathList = 0;
		DEDDemoAdvanced.OutputBatchFile = false;
		DEDDemoAdvanced.OutputLock = false;
		DEDDemoAdvanced.OutputMuteSounds = false;
		DEDDemoAdvanced.OutputPanorama = false;
		DEDDemoAdvanced.OutputHUDS = true;
		DEDDemoAdvanced.OutputShowAssignedTask = true;
		DEDDemoAdvanced.OutputShowBeacons = true;
		DEDDemoAdvanced.OutputShowClientWaypoint = true;
		DEDDemoAdvanced.OutputShowMissionWaypoint = true;
		DEDDemoAdvanced.OutputShowPotentialTask = true;
		DEDDemoAdvanced.OutputShowTargets = true;
		DEDDemoAdvanced.OutputStartTimeMinuteMinimum = 0;
		DEDDemoAdvanced.OutputStartTimeSecondMinimum = 0;
		DEDDemoAdvanced.OutputtingScreenShots = false;
		DEDDemoAdvanced.PathList = "";
		DEDDemoAdvanced.PlayerName = 0;
		DEDDemoAdvanced.PlayerNameDir = 0;
		DEDDemoAdvanced.Prompt = 0;
		DEDDemoAdvanced.Recording = false;
		DEDDemoAdvanced.RecordingHudSize = 1.0;
		DEDDemoAdvanced.RecordOnMapStart = 0;
		DEDDemoAdvanced.SafetySound = "DDA_None_Saf";
		DEDDemoAdvanced.ServerName = 0;
		DEDDemoAdvanced.ServerNameDir = 0;
		DEDDemoAdvanced.ShowCurrentGamma = 0;
		DEDDemoAdvanced.ShowRecordHUD = 0;
		DEDDemoAdvanced.ShowRecordHUDBlink = 0;
		DEDDemoAdvanced.ShowScores = 0;
		DEDDemoAdvanced.SnapshotAt = "Map Start";
		DEDDemoAdvanced.StartRecord = "DDA_Basic_On";
		DEDDemoAdvanced.StartSound = "DDA_None_On";
		DEDDemoAdvanced.StopAtMapEnd = 0;
		DEDDemoAdvanced.StopRecord = "DDA_Basic_Off";
		DEDDemoAdvanced.StopSound = "DDA_None_Off";
		DEDDemoAdvanced.TakeSnapshots = 0;
		DEDDemoAdvanced.TeamName = 0;
		DEDDemoAdvanced.TeamNameDir = 0;
		DEDDemoAdvanced.TextPrefix = 1;
		DEDDemoAdvanced.TextPrefixDir = 0;
		DEDDemoAdvanced.TextPrefixDirText = "";
		DEDDemoAdvanced.TextPrefixText = "Demo";
		DEDDemoAdvanced.TextSeparator = " - ";
		DEDDemoAdvanced.ToggleSafetyMode = false;

		// Load the preferences file and set the preferences for the script.
		DEDDemoAdvanced.LoadPrefs();
	
		// Determine the directory structure for the demo browser.
		DEDDemoAdvanced.GetDirectoryStructure();
	}






//------------------------------------------------------------------------------------------	
// Preference file access functions
//------------------------------------------------------------------------------------------
	// Load DEDDemoAdvanced preferences file.
	function DEDDemoAdvanced::LoadPrefs(%this) {
		if(!isfile("prefs/DEDDemoAdvancedPrefs.cs")) {
			echo("DEDDemoAdvanced Preferences not found -- Setting Defaults");
			DEDDemoAdvanced.SavePrefs();
		} else
			exec("prefs/DEDDemoAdvancedPrefs.cs");
	}


	// Save the DEDDemoAdvanced preferences.
	function DEDDemoAdvanced::SavePrefs(%this) {
		%file = new FileObject();
		%file.openForWrite("prefs/DEDDemoAdvancedPrefs.cs");
		%file.writeline("//----------------------------------------------------------------------------------");
		%file.writeline("// DEDDemoAdvanced Preferences File (Generated by DEDDemoAdvanced V1.0.0)");
		%file.writeline("//----------------------------------------------------------------------------------");
		%file.writeline("");
		%file.writeline("DEDDemoAdvanced.AlwaysRecordTournaments = \"" @ DEDDemoAdvanced.AlwaysRecordTournaments @ "\";");
		%file.writeline("DEDDemoAdvanced.AutomaticSafetyMode = \"" @ DEDDemoAdvanced.AutomaticSafetyMode @ "\";");
		%file.writeline("DEDDemoAdvanced.CurrentDemoFile = \"" @ DEDDemoAdvanced.CurrentDemoFile @ "\";");
		%file.writeline("DEDDemoAdvanced.CurrentPath = \"" @ DEDDemoAdvanced.CurrentPath @ "\";");
		%file.writeline("DEDDemoAdvanced.DeleteSound = \"" @ DEDDemoAdvanced.DeleteSound @ "\";");
		%file.writeline("DEDDemoAdvanced.EnableAudioAlerts = \"" @ DEDDemoAdvanced.EnableAudioAlerts @ "\";");
		%file.writeline("DEDDemoAdvanced.FPS = \"" @ DEDDemoAdvanced.FPS @ "\";");
		%file.writeline("DEDDemoAdvanced.GameType = \"" @ DEDDemoAdvanced.GameType @ "\";");
		%file.writeline("DEDDemoAdvanced.GameTypeDir = \"" @ DEDDemoAdvanced.GameTypeDir @ "\";");
		%file.writeline("DEDDemoAdvanced.GammaCorrection = \"" @ DEDDemoAdvanced.GammaCorrection @ "\";");
		%file.writeline("DEDDemoAdvanced.HUDPosRecordingHud = \"" @ DEDDemoAdvanced.HUDPosRecordingHud @ "\";");
		%file.writeline("DEDDemoAdvanced.HUDPosPlayBackHUD = \"" @ DEDDemoAdvanced.HUDPosPlayBackHUD @ "\";");
		%file.writeline("DEDDemoAdvanced.LastSelected = \"" @ DEDDemoAdvanced.LastSelected @ "\";");
		%file.writeline("DEDDemoAdvanced.MissionName = \"" @ DEDDemoAdvanced.MissionName @ "\";");
		%file.writeline("DEDDemoAdvanced.MissionNameDir = \"" @ DEDDemoAdvanced.MissionNameDir @ "\";");
		%file.writeline("DEDDemoAdvanced.NoSnapShotHUDs = \"" @ DEDDemoAdvanced.NoSnapShotHUDs @ "\";");
		%file.writeline("DEDDemoAdvanced.NumFilters = \"" @ DEDDemoAdvanced.NumFilters @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputBatchFile = \"" @ DEDDemoAdvanced.OutputBatchFile @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputFinishTime = \"" @ DEDDemoAdvanced.OutputFinishTime @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputMuteSounds = \"" @ DEDDemoAdvanced.OutputMuteSounds @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputHUDS = \"" @ DEDDemoAdvanced.OutputHUDS @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputPanorama = \"" @ DEDDemoAdvanced.OutputPanorama @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowAssignedTask = \"" @ DEDDemoAdvanced.OutputShowAssignedTask @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowBeacons = \"" @ DEDDemoAdvanced.OutputShowBeacons @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowClientWaypoint = \"" @ DEDDemoAdvanced.OutputShowClientWaypoint @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowMissionWaypoint = \"" @ DEDDemoAdvanced.OutputShowMissionWaypoint @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowPotentialTask = \"" @ DEDDemoAdvanced.OutputShowPotentialTask @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputShowTargets = \"" @ DEDDemoAdvanced.OutputShowTargets @ "\";");
		%file.writeline("DEDDemoAdvanced.OutputStartTime = \"" @ DEDDemoAdvanced.OutputStartTime @ "\";");
		%file.writeline("DEDDemoAdvanced.PlayerName = \"" @ DEDDemoAdvanced.PlayerName @ "\";");
		%file.writeline("DEDDemoAdvanced.PlayerNameDir = \"" @ DEDDemoAdvanced.PlayerNameDir @ "\";");
		%file.writeline("DEDDemoAdvanced.Prompt = \"" @ DEDDemoAdvanced.Prompt @ "\";");
		%file.writeline("DEDDemoAdvanced.RecordingHudSize = \"" @ DEDDemoAdvanced.RecordingHudSize @ "\";");
		%file.writeline("DEDDemoAdvanced.RecordOnMapStart = \"" @ DEDDemoAdvanced.RecordOnMapStart @ "\";");
		%file.writeline("DEDDemoAdvanced.SafetySound = \"" @ DEDDemoAdvanced.SafetySound @ "\";");
		%file.writeline("DEDDemoAdvanced.ServerModName = \"" @ DEDDemoAdvanced.ServerModName @ "\";");
		%file.writeline("DEDDemoAdvanced.ServerModNameDir = \"" @ DEDDemoAdvanced.ServerModNameDir @ "\";");
		%file.writeline("DEDDemoAdvanced.ServerName = \"" @ DEDDemoAdvanced.ServerName @ "\";");
		%file.writeline("DEDDemoAdvanced.ServerNameDir = \"" @ DEDDemoAdvanced.ServerNameDir @ "\";");
		%file.writeline("DEDDemoAdvanced.ShowCurrentGamma = \"" @ DEDDemoAdvanced.ShowCurrentGamma @ "\";");
		%file.writeline("DEDDemoAdvanced.ShowRecordHUD = \"" @ DEDDemoAdvanced.ShowRecordHUD @ "\";");
		%file.writeline("DEDDemoAdvanced.ShowRecordHUDBlink = \"" @ DEDDemoAdvanced.ShowRecordHUDBlink @ "\";");
		%file.writeline("DEDDemoAdvanced.ShowScores = \"" @ DEDDemoAdvanced.ShowScores @ "\";");
		%file.writeline("DEDDemoAdvanced.SnapshotAt = \"" @ DEDDemoAdvanced.SnapshotAt @ "\";");
		%file.writeline("DEDDemoAdvanced.StartRecord = \"" @ DEDDemoAdvanced.StartRecord @ "\";");
		%file.writeline("DEDDemoAdvanced.StartSound = \"" @ DEDDemoAdvanced.StartSound @ "\";");
		%file.writeline("DEDDemoAdvanced.StopAtMapEnd = \"" @ DEDDemoAdvanced.StopAtMapEnd @ "\";");
		%file.writeline("DEDDemoAdvanced.StopRecord = \"" @ DEDDemoAdvanced.StopRecord @ "\";");
		%file.writeline("DEDDemoAdvanced.StopSound = \"" @ DEDDemoAdvanced.StopSound @ "\";");
		%file.writeline("DEDDemoAdvanced.TakeSnapshots = \"" @ DEDDemoAdvanced.TakeSnapshots @ "\";");
		%file.writeline("DEDDemoAdvanced.TeamName = \"" @ DEDDemoAdvanced.TeamName @ "\";");
		%file.writeline("DEDDemoAdvanced.TeamNameDir = \"" @ DEDDemoAdvanced.TeamNameDir @ "\";");
		%file.writeline("DEDDemoAdvanced.TextPrefix = \"" @ DEDDemoAdvanced.TextPrefix @ "\";");
		%file.writeline("DEDDemoAdvanced.TextPrefixDir = \"" @ DEDDemoAdvanced.TextPrefixDir @ "\";");
		%file.writeline("DEDDemoAdvanced.TextPrefixText = \"" @ DEDDemoAdvanced.TextPrefixText @ "\";");
		%file.writeline("DEDDemoAdvanced.TextSeparator = \"" @ DEDDemoAdvanced.TextSeparator @ "\";");
		%file.writeline("DEDDemoAdvanced.ToggleSafetyMode = \"" @ DEDDemoAdvanced.ToggleSafetyMode @ "\";");
		%file.writeline("DEDDemoAdvanced.TournamentModeCheck = \"" @ DEDDemoAdvanced.TournamentModeCheck @ "\";");
		
		%file.close();
		%file.delete();
		%file = "";
		
		
	}






//------------------------------------------------------------------------------------------	
// Delete demo recording functions
//------------------------------------------------------------------------------------------
	// Finds the file and path of the demo in the recording list and prompts the user to accept or reject the deletion.
	function DEDDemoAdvanced::DeleteSelectedDemo(%this) {
		%sel = RecordingsDlgList.getSelectedId();
		%rowText = RecordingsDlgList.getRowTextById(%sel);
	
		if (getField(%rowText,2) !$= "   ") {
			%fileName = getField(%rowText, 0);
			%fileWithPath = getField(%rowText,3) @ "" @ %fileName;

			// Triggers the doRecordingDelete function if accepted.
			messageBoxOkCancel("Delete Recording?", "Are you sure you wish to delete recording file '" @ %fileName @ "'?", "doRecordingDelete(\"" @ %fileWithPath @ "\");");
		}
	}






//------------------------------------------------------------------------------------------	
// Directory support functions
//------------------------------------------------------------------------------------------
	// Builds a list of directories and sub-directories of the recordings folder for use with
	// the recordings browser.  This list includes directories without .rec files in them.
	function DEDDemoAdvanced::GetDirectoryStructure(%this) {
		// Set the initial numbers of paths and the path list itself to nothing.
		DEDDemoAdvanced.PathList = "";
		DEDDemoAdvanced.NumPathList = 0;
		
		// Cycle through all .rec files in the recordings folder and subdirectories...
		%search = "recordings/*.rec";
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
      			%fileName = fileBase(%file);
      			%var = StrStr(%file, %fileName) - 11;
      			%path = getSubStr(%file, 11, %var);
      			
      			// If the path is a sub-directory of the recordings folder.
      			if (%path !$= "") {
      				// Search through the list of paths and determine if the new path 
      				// already exists in the list.
      				%pathFound = false;
      				for (%i = 0; %i < DEDDemoAdvanced.NumPathList; %i++) {
      					if (%path $= DEDDemoAdvanced.PathList[%i])
      						%pathFound = true;
				}
				
				// If not already in the list, add it to the list.
				if (!%pathFound) {
					// Add the path to the list and increment the list count.
					DEDDemoAdvanced.PathList[DEDDemoAdvanced.NumPathList] = %path;
					DEDDemoAdvanced.NumPathList++;
					
					// If the path contains another "/" -- ie. is more than one
					// level deep.
					if (StrStr(%path, "/") != -1) {
						for (%i = StrLen(%path); %i > 0; %i--) {
							if (GetSubStr(%path,%i,1) $= "/") {
				      				// Search through the list of paths and determine if the new path 
      								// already exists in the list.
	      							%pathFound = false;
      								for (%j = 0; %j < DEDDemoAdvanced.NumPathList; %j++) {
      									if (GetSubStr(%path,0,%i+1) $= DEDDemoAdvanced.PathList[%j])
      										%pathFound = true;
								}
				
								// If not already in the list, add it to the list.
								if (!%pathFound) {
									// Add the path to the list and increment the list count.
									DEDDemoAdvanced.PathList[DEDDemoAdvanced.NumPathList] = GetSubStr(%path,0,%i+1);
									DEDDemoAdvanced.NumPathList++;
								}
							}
						}
					}
				}
			}
		}		
	}


	// 
	function DEDDemoAdvanced::CheckDirLevel(%this, %val) {
		%pathCheck = "recordings/" @ DEDDemoAdvanced.CurrentPath;
		if (%val !$= "") {
			if (StrStr(%val, %pathCheck) != -1) {
				%newStr = GetSubStr(%val, StrLen(%pathCheck), StrLen(%val)-StrLen(%pathCheck));
				%pos = StrStr(%newStr, "/");
				if (%val $= %pathCheck)
					return false;
					
				if (%pos == -1 || %pos == StrLen(%newStr)-1 && %val !$= %pathCheck)
					return true;
				else
					return false;
			}
		} else
			return false;
	}


	// Moves the browser to the previous directory.
	function DEDDemoAdvanced::PreviousDirectory(%this) {
		// Set the selected row to the first row (the "..")
		// The get the selected row path information.
		RecordingsDlgList.setSelectedRow(0);		
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		%pname = getField(%rowText,3);
   		
   		// Set the new path based on the row path information.
		DEDDemoAdvanced.CurrentPath = %pname;
		
		// Update the recording browser menu.
		RecordingsDlg.fillRecordingsList();
		DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	}






//---------------------------------------------------------------------
// Make Directory
//---------------------------------------------------------------------
	// Makes a new directory and adds it to the path list.
	function doMakeDirectory() {
		// Get the path and name of the directory from the make directory dialog edit box.
		%dirName = DEDDemoAdvancedMakeDirectory_Edit.getValue();

		// Create the new directory.
		$DEDDemoAdvanced = new FileObject();
		$DEDDemoAdvanced.openForWrite("recordings/" @ DEDDemoAdvanced.CurrentPath @ "" @ %dirName @ "/");
		$DEDDemoAdvanced.close();
		$DEDDemoAdvanced.delete();
		$DEDDemoAdvanced = "";

		// Add the new directory to the path list and directory drop down.
		DEDDemoAdvanced.PathList[DEDDemoAdvanced.NumPathList] = DEDDemoAdvanced.CurrentPath @ "" @ %dirName @ "/";
		DEDDemoAdvancedDirectoryDropDown.add("recordings/" @ DEDDemoAdvanced.PathList[DEDDemoAdvanced.NumPathList], DEDDemoAdvanced.NumPathList+1, 1);
		DEDDemoAdvanced.NumPathList++;

		// Fill the recording list.
		RecordingsDlg.fillRecordingsList();
		
		// Update the recording browser.
		DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	}


	// Called when the make directory button is pressed, 
	// showing the DEDDemoAdvancedMakeDirectoryDlg.
	function DEDDemoAdvanced::MakeDirectory(%this) {
		DEDDemoAdvancedMakeDirectory_Edit.setValue(%file);
   			Canvas.pushDialog(DEDDemoAdvancedMakeDirectoryDlg);
	}






//------------------------------------------------------------------------------------------
// DEDDemoAdvanced GUI Mover Functions
//------------------------------------------------------------------------------------------
	// Set the specified HUD's position.
	function DEDDemoAdvanced::SetHUDPosition(%this, %menu, %position, %snap) {
		%x = getWord(%position, 0);
		%y = getWord(%position, 1);
		
		%menu.setPosition(%x, %y);
	}


	// Determine the offset coordinates of a HUD based on the original and an offset.
	function DEDDemoAdvanced::GetHUDOffset(%this, %original, %offset) {
		%ax = getWord(%original, 0);
		%ay = getWord(%original, 1);
		
		%bx = getWord(%offset, 0);
		%by = getWord(%offset, 1);
		
		%cx = %bx - %ax;
		%cy = %by - %ay;

		%offset = %cx @ " " @ %cy;
		
		return %offset;
	}
	
	
	// Determine the position of the specified hud, based on the original coordinates, 
	// the offset, and whether or not the hud should snap into position.
	function DEDDemoAdvanced::GetHUDPosition(%this, %hud, %original, %offset, %snap) {
		%ax = getWord(%original, 0);
		%ay = getWord(%original, 1);

		%bx = getWord(%offset, 0);
		%by = getWord(%offset, 1);
		
		%cx = %ax - %bx;
		%cy = %ay - %by;

		// Check if the hud is to the left of our above the 0,0 screen boundary and
		// set the coordinates to 0,0 if they are.
		if (%cx < 0)
			%cx = 0;

		if (%cy < 0)
			%cy = 0;

		// Determine the maximum x,y position for the hud, based on its size.
		%sx = getWord(getResolution(), 0);
		%sy = getWord(getResolution(), 1);
		
		%hx = getWord(%hud.getExtent(), 0);
		%hy = getWord(%hud.getExtent(), 1);
		
		%fx = %sx - %hx;
		%fy = %sy - %hy;
		
		// Check if the hud is outside the maximum screen boundaries and set it
		// to the maximum position if they are.
		if (%cx > %fx)
			%cx = %fx;

		if (%cy > %fy)
			%cy = %fy;


		// If the hud should snap to the edges of the screen,
		// then if it is within 5 pixels of the edge, snap it to the edge.
		if (%snap) {
			
			if (%cx < 5)
				%cx = 0;

			if (%cy < 5)
				%cy = 0;

			if (%cx > %fx-5)
				%cx = %fx;

			if (%cy > %fy-5)
				%cy = %fy;
		}

		// Return the final position.
		return %cx @ " " @ %cy;
	}


	// Updates the position of the hud while it is being moved.
	function DEDDemoAdvanced_MoveHUD(%hud, %offset) {
		// Get the new hud position based on the position of the mouse cursor.
		%newpos = DEDDemoAdvanced.GetHUDPosition(%hud, canvas.getcursorpos(), %offset, true);
		
		// Set the new hud position.
		DEDDemoAdvanced.SetHUDPosition(%hud, %newpos);
		
		// Store this position in a temporary variable.
		DEDDemoAdvanced.HUDPosTemp = %newpos;
		canvas.repaint();
		
		// If still moving the hud, reschedule this function to update the hud again.
		if (DEDDemoAdvanced.MovingHUD){
			DEDDemoAdvanced.HUDSchedule = schedule(50, 0, "DEDDemoAdvanced_MoveHUD", %hud, %offset);
		}
	}


	// When the recording hud is clicked on, start or stop moving the hud...
	function DEDDemoAdvancedRecordingHudEvent::onMouseDown(%this, %item, %pos) {
		// If the huds aren't locked...
		if (!DEDDemoAdvanced.HUDLocked) {
			// If already moving the hud and the user left-clicks stop moving and
			// set the position of the hud at the new coordinates.
			if (DEDDemoAdvanced.MovingHUD) {
				DEDDemoAdvanced.MovingHUD = false;
				DEDDemoAdvanced.HUDPosRecordingHud = DEDDemoAdvanced.HUDPosTemp;
				
			// Otherwise...
			} else {
				// Start moving the hud by calling the DEDDemoAdvanced_MoveHUD function.
				DEDDemoAdvanced.MovingHUD = true;
				DEDDemoAdvanced_MoveHUD(DEDDemoAdvancedRecordingHud, DEDDemoAdvanced.GetHUDOffset(DEDDemoAdvanced.HUDPosRecordingHud, %pos));
			}
		}
	}


	// When the recording hud is right-clicked on...
	function DEDDemoAdvancedRecordingHudEvent::onRightMouseDown(%this) {
		// If the hud is being moved, stop moving it, and reset it to its last position.
		if (DEDDemoAdvanced.MovingHUD) {
			DEDDemoAdvanced.MovingHUD = false;
			cancel(DEDDemoAdvanced.HUDSchedule);
			DEDDemoAdvanced.SetHUDPosition(DEDDemoAdvancedRecordingHud, DEDDemoAdvanced.HUDPosRecordingHud);
		}
	}


	// When the playback gui is clicked on, start or stop moving the hud...
	function DDA_PlaybackMainMouseEvent::onMouseDown(%this, %item, %pos) {
		// If already moving the hud and the user left-clicks stop moving and
		// set the position of the hud at the new coordinates.
		if (DEDDemoAdvanced.MovingHUD) {
			DEDDemoAdvanced.MovingHUD = false;
			DEDDemoAdvanced.HUDPosPlayBackHUD = DEDDemoAdvanced.HUDPosTemp;
				
		// Otherwise...
		} else {
			// Start moving the hud by calling the DEDDemoAdvanced_MoveHUD function.
			DEDDemoAdvanced.MovingHUD = true;
			DEDDemoAdvanced_MoveHUD(DDA_PlaybackDlg, DEDDemoAdvanced.GetHUDOffset(DEDDemoAdvanced.HUDPosPlayBackHUD, %pos));
		}
	}


	// When the playback gui is right-clicked on...
	function DDA_PlaybackMainMouseEvent::onRightMouseDown(%this) {
		// If the hud is being moved, stop moving it, and reset it to its last position.
		if (DEDDemoAdvanced.MovingHUD) {
			DEDDemoAdvanced.MovingHUD = false;
			cancel(DEDDemoAdvanced.HUDSchedule);
			DEDDemoAdvanced.SetHUDPosition(DDA_PlaybackDlg, DEDDemoAdvanced.HUDPosPlayBackHUD);
		}
	}






//---------------------------------------------------------------------
// Recording HUD
//---------------------------------------------------------------------
	// Shows the recording hud when called.
	function DEDDemoAdvanced::ShowRecordingHud(%this) {
		// If the recording hud isn't already shown...
		if (!DEDDemoAdvancedRecordingHud.Shown) {
			// Set the position of the HUD
			DEDDemoAdvanced.SetHUDPosition(DEDDemoAdvancedRecordingHud, DEDDemoAdvanced.HUDPosRecordingHud);
		
			// Determine the x and y size of the recoridng hud, based on the scale chosen.
			%px = mFloor(42 * DEDDemoAdvanced.RecordingHudSize) - 1;
			%py = mFloor(25 * DEDDemoAdvanced.RecordingHudSize) - 1;
		
			// Set the extent of the the hud, the mouse event, and the bitmap.
			DEDDemoAdvancedRecordingHud.setExtent(%px, %py);
			DEDDemoAdvancedRecordingHudBitmap.setExtent(%px, %py);
			DEDDemoAdvancedRecordingHudEvent.setExtent(%px, %py);

			// Set the recording graphic.
			DEDDemoAdvancedRecordingHudBitmap.setBitmap("gui/" @ DEDDemoAdvanced.StartRecord @ "");

			// Add the recording hud to the current canvas.
			DEDDemoAdvanced.CanvasID = Canvas.getContent();
			Canvas.getContent().add(DEDDemoAdvancedRecordingHud);
		
			// Set the recording hud as shown.
			DEDDemoAdvancedRecordingHud.Shown = true;
			
			// If the recording hud should blink, start blinking.
			if (DEDDemoAdvanced.ShowRecordHUDBlink)
				DEDDemoAdvanced_FlashRecordingHud();
		}
	}


	// Hides the recording hud.
	function DEDDemoAdvanced::HideRecordingHud(%this) {
		// If the recording hud is shown...
		if (DEDDemoAdvancedRecordingHud.Shown) {
			// Remove the recording hud from the canvas.
			DEDDemoAdvanced.CanvasID.remove(DEDDemoAdvancedRecordingHud);
			canvas.repaint();
			
			// Set the recording hud as not shown.
			DEDDemoAdvancedRecordingHud.Shown = false;
		}
	}


	// DEDDemoAdvancedFlashRecordingHud
	function DEDDemoAdvanced_FlashRecordingHud(%this) {
		// Cancel any existing threads for the update.
		Cancel(DEDDemoAdvanced.FlashHUDUpdate);

		// If hud is visible set to invisible.  If invisible, set visible.
		if (DEDDemoAdvanced.RecordingHUDFlashVisiblity)
			DEDDemoAdvanced.RecordingHUDFlashVisiblity = false;
		else 
			DEDDemoAdvanced.RecordingHUDFlashVisiblity = true;
		
		// Set the recording hud's visibility to DEDDemoAdvanced.RecordingHUDFlashVisiblity
		DEDDemoAdvancedRecordingHud.setVisible(DEDDemoAdvanced.RecordingHUDFlashVisiblity);
		
		// Schedule this function to be called again in 800 ms time only if 
		// the program is currently recording.
		if (DEDDemoAdvanced.Recording) {
			// If the recording hud should flash, schedule it to flash.
			if (DEDDemoAdvanced.ShowRecordHUDBlink)
				DEDDemoAdvanced.FlashHUDUpdate = schedule(800, 0, "DEDDemoAdvanced_FlashRecordingHud");
				
			// Otherwise, set it to visible.
			else {
				DEDDemoAdvancedRecordingHud.setVisible(true);
			}
			
		// Otherwise, hide the recording hud.
		} else {
			DEDDemoAdvanced.HideRecordingHud();
			DEDDemoAdvancedRecordingHud.setVisible(true);
		}
	}


	// Sets the size of the recording hud.
 	function DEDDemoAdvanced::SetRecordingHudSize(%this) {
 		// Get the scale for the recording hud from the size slider.
 		DEDDemoAdvanced.RecordingHudSize = DEDDemoAdvanced_RecordingHudSize.getValue();
 		
 		// Determine the x and y dimensions.
		DEDDemoAdvanced.RecordingHudX = mFloor(42 * DEDDemoAdvanced.RecordingHudSize) -1;
		DEDDemoAdvanced.RecordingHudY = mFloor(25 * DEDDemoAdvanced.RecordingHudSize) -1;
		
		// Set the extent of the graphic.
		DEDDemoAdvancedOnIcon.setExtent(DEDDemoAdvanced.RecordingHudX, DEDDemoAdvanced.RecordingHudY);
		DEDDemoAdvancedRecordingHud.setExtent(DEDDemoAdvanced.RecordingHudX, DEDDemoAdvanced.RecordingHudY);
	}






//---------------------------------------------------------------------
// Sequenced image output functions
//---------------------------------------------------------------------
	// 
	function recordMovie(%movieName, %fps) {
		$timeAdvance = 1000 / %fps + 6;
				
		if (DEDDemoAdvanced.OutputBatchFile) {
			%filecount = 0;
			for(%found = true; %found; %filecount++ ) {
				%suffix = %filecount;
				while (strlen(%suffix) < 5) %suffix = "0" @ %suffix;
				%fileName = "Sequenced Images/Generate_Movie" @ %suffix @ ".bat";
				%found = isFile(%fileName);
			}
			
			DEDDemoAdvanced.SeqFileName = %fileName;			

			$DEDDemoAdvanced = new FileObject(DEDDemoAdvanced.SeqFileName);
			$DEDDemoAdvanced.openForWrite();
			$DEDDemoAdvanced.writeline("@echo off");
			$DEDDemoAdvanced.writeline("echo DEDEN's Demo Advanced AVI Creation File");
			$DEDDemoAdvanced.writeline("echo Generated by DEDEN's Demo Advanced");
			$DEDDemoAdvanced.writeline("echo");
			$DEDDemoAdvanced.writeline("");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		
		movieGrabScreen(%movieName, 0);
	}

	function DDA_ToggleOutputHUDS(%val) {
		if (!DEDDemoAdvanced.OutputHUDS) {
	     		clientCmdTogglePlayHuds(!%val);
     			//bottomPrintDlg.setVisible(%val);
		}

		if (DEDDemoAdvanced.OutputPanorama && %val) {
			if (!%val) {
				Canvas.setContent(PanoramaGui);
				PanoramaGui.beaconsVisible = false;
				if ($cursorControlled) 
					lockMouse(true);

				Canvas.cursorOff();
				$pref::interior::showdetailmaps = false;
			}
		}
		
		if (!DEDDemoAdvanced.OutputPanorama && !%val)
			Canvas.setContent(PlayGui);

		if(!DEDDemoAdvanced.OutputShowClientWaypoint)
      			navHud.setMarkerTypeVisible(ClientWaypoint, %val); 

      		if(!DEDDemoAdvanced.OutputShowMissionWaypoint)	
      			navHud.setMarkerTypeVisible(MissionWaypoint, %val);

		if(!DEDDemoAdvanced.OutputShowTargets)
			navHud.setMarkerTypeVisible(Target, %val);

		if(!DEDDemoAdvanced.OutputShowPotentialTask)
			navHud.setMarkerTypeVisible(PotentialTask, %val);

		if(!DEDDemoAdvanced.OutputShowAssignedTask)
			navHud.setMarkerTypeVisible(AssignedTask, %val);

		if(!DEDDemoAdvanced.OutputShowBeacons)
			PlayGui.beaconsVisible = %val;
	}

	function movieGrabScreen(%movieName, %frameNumber) {
		if(%frameNumber < 10)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 100)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 1000)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 10000)
			%frameNumber = "0" @ %frameNumber;

		DDA_ToggleOutputHUDS(false);

		if (DEDDemoAdvanced.OutputBatchFile) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForAppend(DEDDemoAdvanced.SeqFileName);
			$DEDDemoAdvanced.writeline("tools\abc " @ %movieName @ %frameNumber @ ".png /convert=" @ %movieName @ %frameNumber @ ".tga");
			//$DEDDemoAdvanced.writeline("del " @ %movieName @ %frameNumber @ ".png");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		screenshot(%movieName @ DEDDemoAdvanced.TextSeparator @ DEDDemoAdvanced.OutputFileText @ DEDDemoAdvanced.TextSeparator @ %frameNumber @ ".png");

		DDA_ToggleOutputHUDS(true);

		$screenGrabThread = schedule($timeAdvance, 0, "movieGrabScreen", %movieName, (%frameNumber + 1));
	}

	function stopMovie() {
		cancel($screenGrabThread);
	}

	function DEDDemoAdvancedStopDemoOutputting() {
		if (DEDDemoAdvanced.SnapshotAt $= "Output End") {
			if(!isFile("textures/snapshots/" @ DEDDemoAdvanced.CurrentDemoFile @ ".png")) {
				DEDDemoAdvanced.ReplaceSnapshot();
			}
		}

		cancel($DEDDemoAdvancedSchedule);
		
		%val = DEDDemoAdvanced_GetNextTime();
		if (%val != -1) {
			cancel($screenGrabThread);
			if(DEDDemoAdvanced.OutputLock)
				DEDDemoAdvanced.OutputLock = false;

			DEDDemoAdvanced.OutputStartMatch = %val;
			DEDDemoAdvanced.OutputFinishMatch = DEDDemoAdvanced_GetNextTime();
		} else {
			stopDemoPlayback();	
		}
	}

	function DEDDemoAdvancedStartOutputtingScreens() {
		if (DEDDemoAdvanced.SnapshotAt $= "Output Start") {
			if(!isFile("textures/snapshots/" @ DEDDemoAdvanced.CurrentDemoFile @ ".png")) {
				DEDDemoAdvanced.ReplaceSnapshot();
			}
		}

		DEDDemoAdvanced.OutputLock = true;
		$DemoPlaybackIndex = 1;
		if(DDA_PlaybackDlg.isAwake())
			Canvas.popDialog(DDA_PlaybackDlg);

		if (DEDDemoAdvanced.ShowCurrentGamma)
			videoSetGammaCorrection( DEDDemoAdvanced.GammaCorrection );

		recordMovie(DEDDemoAdvanced.ScreenShotsName, DEDDemoAdvanced.FPS);
	}


	function DEDDemoAdvancedStartOutputtingScreenShots() {
		DEDDemoAdvanced.OutputtingScreenShots = true;
		
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		DEDDemoAdvanced.CurrentDemoFile = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";
	
     	%val = DEDDemoAdvanced.CurrentDemoFile @ ".png";
		%valtwo = getSubStr(%val, 11, (strlen(%val) - 19));
		
		echo("file = " @ %valtwo);
		if (StrStr(%valtwo,"/") != -1) {
			%i = Strlen(%valtwo);
			while(%i > 0 && GetSubStr(%valtwo,%i,1) !$= "/") {
				%i--;
			}
		
			if (%i > 0) {
				%fPath = "Sequenced Images/" @ GetSubStr(%valtwo,0,%i) @ "/";
				$DEDDemoAdvanced = new FileObject();
				$DEDDemoAdvanced.openForWrite(%fPath);
				$DEDDemoAdvanced.close();
				$DEDDemoAdvanced.delete();
				$DEDDemoAdvanced = "";
			}	
		}
	
		if (DEDDemoAdvanced.OutputMuteSounds) {
			DEDDemoAdvanced.PreviousVolume = $pref::Audio::masterVolume;
			alxListenerf( AL_GAIN_LINEAR, 0 );
		}

		DEDDemoAdvanced.ScreenShotsName = "base/Sequenced Images/" @ %valtwo @ "";
		DEDDemoAdvanced.OutputLock = false;
		
		DEDDemoAdvanced.OutputStartTime = DDA_OutputStartTimeMinuteDropDown.getValue() @ ":" @ DDA_OutputStartTimeSecondDropDown.getValue();
		DEDDemoAdvanced.OutputFinishTime = DDA_OutputFinishTimeMinuteDropDown.getValue() @ ":" @ DDA_OutputFinishTimeSecondDropDown.getValue();
		$DDATMP::CurrentBatchTime = 0;
		DEDDemoAdvanced.OutputStartMatch = DEDDemoAdvanced_GetNextTime();
		DEDDemoAdvanced.OutputFinishMatch = DEDDemoAdvanced_GetNextTime();

		StartSelectedDemo();
	}







//------------------------------------------------------------------------------------------	
// Recording browser functions
//------------------------------------------------------------------------------------------
	// Called whenever the RecordingsDlg is woken.
	function RecordingsDlg::onWake(%gui) {
		// Fills the list of files and directories.
   		%gui.fillRecordingsList();

		// Set the current row to the last selected.
   		RecordingsDlgList.SetSelectedRow(DEDDemoAdvanced.LastSelected);
   		
		// Update the recording buttons, snapshot picture, filename, drop-down box and so on.
   		updateRecordingButtons();
  		DEDDemoAdvancedUpdateSnapshotPic();
  		DEDDemoAdvancedUpdateFilename();
  		DEDDemoAdvancedDirectoryDropDownFiller();
	}


	// Populates the drop-down box.
	function DEDDemoAdvancedDirectoryDropDownFiller() {
		// Clears the directory drop-down.
		DEDDemoAdvancedDirectoryDropDown.clear();

		// Always add the default recordings directory at the top of the list.		
		DEDDemoAdvancedDirectoryDropDown.add( "recordings/", 0, 1 );
		
		// Add every path in the path list to the directory drop down.
		for (%i = 0; %i < DEDDemoAdvanced.NumPathList; %i++) {
			DEDDemoAdvancedDirectoryDropDown.add( "recordings/" @ DEDDemoAdvanced.PathList[%i], %i+1, 1 );
		}
		
		// Update the drop down box for the current entry.
		DEDDemoAdvancedDirectoryDropDownUpdate(DEDDemoAdvanced.CurrentPath);
	}


	// Updates the directory drop down box based on the current path.
	function DEDDemoAdvancedDirectoryDropDownUpdate(%setTo) {
		// If it's not the root recording path, cycle through all the directory entries
		// in the path list till a match is found and then set the drop down based on that.
		if (%setTo !$= "") {
			for (%i = 0; %i < DEDDemoAdvanced.NumPathList; %i++) {
				if (DEDDemoAdvanced.PathList[%i] $= %setTo) {
					DEDDemoAdvancedDirectoryDropDown.setSelected(%i+1);
				}
			}

		// Otherwise, set the first entry in the drop down as selected.
		} else
			DEDDemoAdvancedDirectoryDropDown.setSelected(0);
		
		// Deactivate the up directory button if at the root, activate it otherwise.		
		if (DEDDemoAdvancedDirectoryDropDown.getValue() $= "recordings/")
			DEDDemoAdvancedUpDirectoryBtn.setActive(false);
		else
			DEDDemoAdvancedUpDirectoryBtn.setActive(true);
	}

	
	// Whenever a directory is selected from the directory drop down, update the browser.
	function DEDDemoAdvancedDirectoryDropDown::onSelect( %this, %id, %text ) {
		// Get the actual path from the drop down.
		%pname = GetSubStr(DEDDemoAdvancedDirectoryDropDown.getValue(), 11, StrLen(DEDDemoAdvancedDirectoryDropDown.getValue())-11);
		
		// Set the new path.
		DEDDemoAdvanced.CurrentPath = %pname;
			
		// Update the browser list.
		RecordingsDlg.fillRecordingsList();
		
		// Deactivate the up directory button if at the root, activate it otherwise.
		if (DEDDemoAdvancedDirectoryDropDown.getValue() $= "recordings/")
			DEDDemoAdvancedUpDirectoryBtn.setActive(false);
		else
			DEDDemoAdvancedUpDirectoryBtn.setActive(true);
	}


	function updateRecordingButtons() {
   		%active = RecordingsDlgList.rowCount() != 0;
   
   		if(%active)
      			PR_StartDemoBtn.makeFirstResponder(1);
   		else
      			PR_CancelBtn.makeFirstResponder(1);
	}

	function DEDDemoAdvancedUpdateRecordingList() {
		%val = 0;
		%num = 0;
		
		if (DEDDemoAdvanced.CurrentPath !$= "") {
			%i = StrLen(DEDDemoAdvanced.CurrentPath)-2;
			%tt = " ";
			
			while (%tt !$= "/" && %i > 0) {
				%tt = GetSubStr(DEDDemoAdvanced.CurrentPath,%i,1);
				%i--;
			}
			
			if (%i >0)			
				%grud = GetSubStr(DEDDemoAdvanced.CurrentPath, 0, %i+2);
			else
				%grud = "";

			RecordingsDlgList.addRow(0, ".." TAB "   " TAB "   " TAB %grud);
			RecordingsDlgList.setRowStyle(%num, 1);
			%num++;
		}
		
		for (%i = 0; %i < DEDDemoAdvanced.NumPathList; %i++) {
			if (DEDDemoAdvanced.CheckDirLevel("recordings/" @ DEDDemoAdvanced.PathList[%i])) {
				%dirName = DEDDemoAdvanced.PathList[%i];
				
				%newStr = GetSubStr(%dirName, StrLen(DEDDemoAdvanced.CurrentPath), StrLen(%dirName)-StrLen(DEDDemoAdvanced.CurrentPath));
				%pos = StrStr(%newStr, "/");
				
				if (%pos != -1 || %pos != StrLen(%newStr)-1)
					%dirName = %newStr;
				
				RecordingsDlgList.addRow(%num, %dirName TAB "   " TAB "   " TAB DEDDemoAdvanced.PathList[%i]);
				RecordingsDlgList.setRowStyle(%num, 1);
				%num++;
			}
		}
		
		return %num;
	}

	function RecordingsDlg::fillRecordingsList(%gui) {
		if(!%gui.initialized) {
      			RecordingsDlgList.setSortColumn(0);
      			RecordingsDlgList.setSortIncreasing(true);

      			RecordingsDlgList.addStyle(1, $ShellLabelFont, 12, "80 220 200", "30 255 225", "10 60 40" );
      			RecordingsDlgList.addStyle(2, $ShellLabelFont, 12, "120 120 120", "120 120 120", "120 120 120" );

			RecordingsDlgList.addColumn(0, "Recording", 150, 150, 250);
			RecordingsDlgList.addColumn(1, "Time", 90, 90, 90, "filetime center");
			RecordingsDlgList.addColumn(2, "Length", 40, 40, 40, "center");
			RecordingsDlgList.addColumn(3, "Path", 50, 50, 200);
      
      			%gui.initialized = true;
		}

   		RecordingsDlgList.clear();
   		RecordingsDlgList.clearList();

		%search = "recordings/*.rec";
		%ct = DEDDemoAdvancedUpdateRecordingList();
		%demoVersion = getDemoVersion();

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
      			%fileName = fileBase(%file);
      			
      			%var = StrStr(%file, %fileName) - 11;
      			%path = getSubStr(%file, 11, %var);

			if (DEDDemoAdvanced.CheckDirLevel(%file)) {
				%val = getDemoVersionLength(%file);
				%version = getField(%val, 0);

				if(%version == -1) {
					%version = "???";
					%length = "???";
				} else
         				%length = msToMinSec(getField(%val, 1));
         				
				%fileTime = getFileModifyTime(%file);
      				RecordingsDlgList.addRow(%ct, %fileName TAB %fileTime TAB %length TAB %path);
				RecordingsDlgList.setRowStyle(%ct, (%version == %demoVersion) ? 1 : 2);
      
				%ct++;
			}
		}

		RecordingsDlgList.sort(0, true);
		RecordingsDlgList.setSelectedRow(DEDDemoAdvanced.LastSelected);
	}

	function DEDDemoAdvancedUpdateDetails(){
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		if (getField(%rowText,2) !$= "   ") {
			%active = RecordingsDlgList.rowCount() != 0;
			PR_StartDemoBtn.setActive(%active);
			PR_DeleteDemoBtn.setActive(%active);
			PR_RenameDemoBtn.setActive(%active);
			DDA_OutputDemoBtn.setActive(%active);
		} else {
			PR_StartDemoBtn.setActive(false);
			PR_DeleteDemoBtn.setActive(false);
			PR_RenameDemoBtn.setActive(false);
			DDA_OutputDemoBtn.setActive(false);
		}
		
		DEDDemoAdvancedUpdateSnapshotPic();
		DEDDemoAdvancedUpdateFilename();	
	}
	
	function DEDDemoAdvancedUpdateFilename(){
   		%sel = RecordingsDlgList.getSelectedId();
   		DEDDemoAdvanced.LastSelected = %sel;
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		if (getField(%rowText,2) !$= "   ") {
			DEDDemoAdvancedFilenameDisplay.setText("Play Demo File:  " @ getField(%rowText, 0) @ ".rec");
		} else {
			%pathName = getField(%rowText,0);
			if (%pathName !$= "..") {
				%pName = GetSubStr(%pathName,0,StrLen(%pathName)-1);
				DEDDemoAdvancedFilenameDisplay.setText("Change Directory to " @ %pName @ "");
			} else 
				DEDDemoAdvancedFilenameDisplay.setText("Back to Previous Directory");
		}
	}

	function DEDDemoAdvancedUpdateSnapshotPic(){
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		
   		%temp = DEDDemoAdvanced.CurrentPath @ getField(%rowText, 0);

   		%snapshotBmp = "snapshots/" @ %temp @ ".png";
   		
	      	if ( !isFile( "textures/" @ %snapshotBmp) ) {
	      		%snapshotBmp = "snapshots/No_Screen.png";
	      		DEDDemoAdvancedScreenMagnify.setVisible(false);
	      	} else
	      		DEDDemoAdvancedScreenMagnify.setVisible(true);

		DEDDemoAdvancedScreenPreview.setBitmap(%snapshotBmp);
		DEDDemoAdvancedFullScreenPictureView.setBitmap(%snapshotBmp);
		
		if (%snapshotBmp !$= "snapshots/No_Screen.png") {
			DEDDemoAdvancedLoadingPicture.setBitmap(%snapshotBmp);
			DEDDemoAdvancedLoadingName.setVisible(true);
			$DDATemp::LoadingPic = %snapshotBmp;
		} else {
			DEDDemoAdvancedLoadingPicture.setBitmap("");
			DEDDemoAdvancedLoadingName.setVisible(false);
			$DDATemp::LoadingPic = "";
		}
	}

	function DEDDemoAdvancedShowFullSnapShot() {
		Canvas.pushdialog(DEDDemoAdvancedFullScreenPicture);
	}








	function DEDDemoAdvancedAddOutputTimeToList() {
		%startTime = DDA_OutputStartTimeMinuteDropDown.getValue() @ ":" @ DDA_OutputStartTimeSecondDropDown.getValue();
		%finishTime = DDA_OutputFinishTimeMinuteDropDown.getValue() @ ":" @ DDA_OutputFinishTimeSecondDropDown.getValue();
		
		%min = DDA_OutputFinishTimeMinuteDropDown.getValue();
		%sec = DDA_OutputFinishTimeSecondDropDown.getValue();
		if (getSubStr(%min,0,1) $= "0")
			%min = getSubStr(%min, 1, 1);

		if (getSubStr(%sec,0,1) $= "0")
			%sec = getSubStr(%sec, 1, 1);

		DEDDemoAdvanced.OutputStartTimeMinuteMinimum = %min;
		DEDDemoAdvanced.OutputStartTimeSecondMinimum = %sec;
		%entry = %startTime @ " - " @ %finishTime;
		
		DEDDemoAdvanced.BatchList[DEDDemoAdvanced.NumBatchList] = %entry;
		DEDDemoAdvanced.NumBatchList++;
		
		DEDDemoAdvanced_AddTime(%startTime, %finishTime);

		DEDDemoAdvanced.OutputStartTimeMinute = DEDDemoAdvanced.OutputStartTimeMinuteMinimum;
		DEDDemoAdvanced.OutputStartTimeSecond = DEDDemoAdvanced.OutputStartTimeSecondMinimum;
		DEDDemoAdvanced.OutputFinishTimeMinute = DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength);
		DEDDemoAdvanced.OutputFinishTimeSecond = DEDDemoAdvanced.GetSecondsFromTime(DEDDemoAdvanced.DemoOutputLength);
		
		if (DEDDemoAdvanced.OutputStartTimeMinute == DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength) &&
		DEDDemoAdvanced.OutputStartTimeSecond == DEDDemoAdvanced.GetSecondsFromTime(DEDDemoAdvanced.DemoOutputLength)) {
			DDA_OutputAddToList.setActive(false);
		}

		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
		OutputSelectedDemoDlg.fillList();
	}

	function OutputSelectedDemoDlg::fillList(%gui) {
		if(!%gui.initialized) {
      			DDABatchList.setSortColumn(0);
      			DDABatchList.setSortIncreasing(true);

      			DDABatchList.addStyle(1, $ShellLabelFont, 12, "80 220 200", "30 255 225", "10 60 40" );
      			DDABatchList.addStyle(2, $ShellLabelFont, 12, "120 120 120", "120 120 120", "120 120 120" );

			DDABatchList.addColumn(0, "Output Tasks", 150, 150, 250);
     
      			%gui.initialized = true;
		}

   		DDABatchList.clear();
   		DDABatchList.clearList();

		if (DEDDemoAdvanced.NumBatchList > 0) {
			for (%i = 0; %i < DEDDemoAdvanced.NumBatchList; %i++) {
				DDABatchList.addRow(%ct, DEDDemoAdvanced.BatchList[%i]);
				DDABatchList.setRowStyle(%ct, 1);
			}
		}
		
		DDABatchList.sort(0, true);
	}






//---------------------------------------------------------------------
// Recording renaming
//---------------------------------------------------------------------

	function doDemoFileRename() {
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		
   		if (getField(%rowText,2) !$= "   ") {
   			%file = getField(%rowText,3) @ "" @ getField(%rowText, 0);

   			%newFile = getField(%rowText,3) @ DemoRenameFile_Edit.getValue();
   
   			if(%file $= %newFile)
      				return;

	   		if(%newFile !$= "") {
      				if(renameFile("recordings/" @ %file @ ".rec", "recordings/" @ %newFile @ ".rec")) {
         				rebuildModPaths();
         				RecordingsDlg.fillRecordingsList();
         			
	      				if(isFile("textures/snapshots/" @ %file @ ".png")) {
      						if(renameFile("textures/snapshots/" @ %file @ ".png", "textures/snapshots/" @ %newFile @ ".png")) {
							// Do nothing.
		      				} else
      							echo("Snapshot renaming failed...");
	      				}
	      			
         				return;
      				}
	   		}

   			MessageBoxOK("Rename Failed", "Failed to rename file '" @ %file @ ".rec' to '" @ %newFile @ "'.rec.");
		}
	}
	
	function RenameSelectedDemo() {
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);
   	
   		if (getField(%rowText,2) !$= "   ") {	
	   		%file = getField(%rowText, 0);

   			DemoRenameFile_Edit.setValue(%file);
   			Canvas.pushDialog(DemoRenameFileDlg);
   		}
	}






//------------------------------------------------------------------------------------------	
// Last demo deletion functions
//------------------------------------------------------------------------------------------
	// Prompts the user as to whether or not the last recorded demo file should be deleted.
	function DEDDemoAdvanced::DeleteLastDemo(%this) {
		// If there is a last demo entry, we aren't recording, and this isn't a demo itself...
		if (DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] !$= "" && 
		!isRecordingDemo() && !isDemo() && DEDDemoAdvanced.LastDemoFileNumber > 0) {
			// Get the filename of the last demo.
			%fName = GetSubStr(DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber],0,Strlen(DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber])-4);
			
			// Bring up a message box, prompting the user to accept or reject the deletion.
			// Trigger the DEDDemoAdvanced.DeleteLastDemoFile function on accept.
			messageBoxOkCancel("Delete Recording?", "Are you sure you wish to delete the last demo file 'recordings/" @ DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] @ "'?", "DEDDemoAdvanced.DeleteLastDemoFile(\"" @ %fName @ "\");");
		}
	}

	
	// Delete the specified demo file.
	function DEDDemoAdvanced::DeleteLastDemoFile(%this, %file) {
		// Delete the demo.
		if(deleteFile("recordings/" @ %file @ ".rec")) {
			// If a snapshot exists for the demo, attempt to delete it too.
     			if(isFile("textures/snapshots/" @ %file @ ".png")) {
      				if(deleteFile("textures/snapshots/" @ %file @ ".png")) {
      					// do nothing
      				} else
      					echo("Snapshot deletion failed...");
      			}
      			
      			// Notify the user of the deletion in the HUD.
			addMessageHudLine( "\c4Deleted Last Recording File: \c2" @ DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] @ "\cr");
			
			// If audio alerts are enabled and there is a sound for deletion, play that sound.
			if (DEDDemoAdvanced.DeleteSound !$= "None" && DEDDemoAdvanced.EnableAudioAlerts)
				DEDDemoAdvancedPlaySound(DEDDemoAdvanced.DeleteSound);

   		} else 
   			// Otherwise, add an error message to the HUD.
      			addMessageHudLine( "\c4Failed to Delete Recording File: \c2" @ DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] @ "\cr");

		// Remove this entry from the last demo file list.
		DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] = "";
		DEDDemoAdvanced.LastDemoFileNumber--;
	}






//------------------------------------------------------------------------------------------	
// Filename generation functions
//------------------------------------------------------------------------------------------
	// Filters illegal characters out of a filename.
	function DEDDemoAdvanced::FilterIllegalCharacters(%this, %file){
		%varName = "";
		
		// Creates a new, empty string and then cycles through each character in the 
		// filename, add only legal characters to the new string.
		for ( %i = 0;  %i <= strlen(%file); %i++ ) {
			%varChar = getSubStr(%file, %i, 1);
                        if (%varChar !$= "\\" && %varChar !$= "/" && %varChar !$= ":" && %varChar !$= "*" && %varChar !$= ">" && %varChar !$= "<" && %varChar !$= "?") {
				%varName = %varName @ %varChar;
			} else { 
				%varName = %varName @ "";
			}
		}
		
		// Returns the new string (old string minus illegal characters).
		return %varName;
	}


	// Generates a filename based on the script settings.  This filename uses values based on
	// either the current player/ server/ mission settings or default player/ server/ mission
	// values, if %val is set to zero (like when called from the options menu).
	function DEDDemoAdvanced::GenerateDemoFileName(%this, %val){
		// Create two new blank strings.
		%baseFile = "";
		%xbaseFile = "";
		
		// Set the text separator between filename values.
		%sVal = DEDDemoAdvanced.TextSeparator;

		// Adds the text prefix to the string as a directory.
		if (DEDDemoAdvanced.TextPrefixDir && DEDDemoAdvanced.TextPrefixDirText !$= "")
			%baseFile = %baseFile @ "" @ DEDDemoAdvanced.TextPrefixDirText @ "/";
		
		// Adds the current player name to the string as a directory.
		if (DEDDemoAdvanced.PlayerNameDir) {
			%pname = getField( $pref::Player[$pref::Player::Current], 0 );
			%baseFile = %baseFile @ "" @ %pname @ "/";
		}
	   	
	   	// Adds the server name to the string as a directory.
		if (DEDDemoAdvanced.ServerNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getServerName() @ "/";
			} else {
				%baseFile = %baseFile @ "Tribes 2 Server/";
			}
		}

		// Adds the server mod name to the string as a directory.
		if (DEDDemoAdvanced.ServerModNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getServerMod() @ "/";
			} else {
				%baseFile = %baseFile @ "Base/";
			}
		}

		// Adds the mission name to the string as a directory.
		if (DEDDemoAdvanced.MissionNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getMissionName() @ "/";
			} else {
				%baseFile = %baseFile @ "Katabatic/";
			}
		}
		
		// Adds the game type to the string as a directory.
		if (DEDDemoAdvanced.GameTypeDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getMissionType() @ "/";
			} else {
				%baseFile = %baseFile @ "CTF/";
			}
		}
   		
   		// Adds the team name to the string as a directory.
		if (DEDDemoAdvanced.TeamNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ PlayerList.getTeamByID(PlayerList.getMyID()) @ "/";
			} else {
				%baseFile = %baseFile @ "Starwolf/";
			}
		}

		// Adds the text prefix to the string as part of the filename.
		if (DEDDemoAdvanced.TextPrefix && DEDDemoAdvanced.TextPrefixText !$= "")
			%xbaseFile = %xbaseFile @ "" @ DEDDemoAdvanced.TextPrefixText @ %sVal;
			
		// Adds the player name to the string as part of the filename.
		if (DEDDemoAdvanced.PlayerName) {
			%pname = getField( $pref::Player[$pref::Player::Current], 0 );
			%xbaseFile = %xbaseFile @ "" @ %pname @ %sVal;
		}
	   	
	   	// Adds the server name to the string as part of the filename.
		if (DEDDemoAdvanced.ServerName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getServerName() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Tribes 2 Server" @ %sVal;
			}
		}

		// Adds the server mod name to the string as part of the filename.
		if (DEDDemoAdvanced.ServerModName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getServerMod() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Base" @ %sVal;
			}
		}

		// Adds the mission name to the string as part of the filename.
		if (DEDDemoAdvanced.MissionName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getMissionName() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Katabatic" @ %sVal;
			}
		}

		// Adds the game type to the string as part of the filename.
		if (DEDDemoAdvanced.GameType) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getMissionType() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "CTF" @ %sVal;
			}
		}
   
   		// Adds the team name to the string as part of the filename.
		if (DEDDemoAdvanced.TeamName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ PlayerList.getTeamByID(PlayerList.getMyID()) @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Starwolf" @ %sVal;
			}
		}
  
  		// Adds a numeric to the end of the filename based on how many files already have
  		// a similar directory and filename.  If the function is called from options menu,
  		// this defaults to a flat value of 00000.rec
   		if (%val > 0) {
			$DemoCount = 0;
			for(%found = true; %found; $DemoCount++ ) {
				%suffix = $DemoCount;
				while (strlen(%suffix) < 5) %suffix = "0" @ %suffix;
				%file = %xbaseFile @ "" @ %suffix @ ".rec";
				%found = isFile("recordings/" @ %baseFile @ "" @ %file);
			}
		} else {
			%file = %xbaseFile @ "00000.rec";	
		}

		// ??? Can't remember what this is for but it works so I'm not touching it. =)		
		if (%val == 2)
			%finishedFile = %baseFile;
		else if (%val == 3)
			%finishedFile = DEDDemoAdvanced.FilterIllegalCharacters(%file);
		else
			%finishedFile = %baseFile @ "" @ DEDDemoAdvanced.FilterIllegalCharacters(%file);
		
		// Returns the newly generated path and filename as a string.
		return %finishedFile;
	}


	// Takes a path/filename string and adds flavour text to it, formatting in the directory
	// graphics, dropping lines, etc.
	function DEDDemoAdvanced::AddTextFlavour(%this, %fName) {
		%fName = "Recordings/" @ %fName;
		%newName = "<lmargin:5>";
		%dirNum = 0;
		
		// Every time a "/" is encountered, add the initial folder picture.
		if (StrStr(%fName,"/") != -1)
			%newName = %newName @ "<color:00dc00><bitmap:DDA_FolderPic> ";
		else	
			%newName = %newName @ "<color:C0C0C0>";

		// Cycles through each character in the string, checking for the "/" character.
		for (%i=0; %i < StrLen(%fName); %i++) {
			%fChar = GetSubStr(%fName,%i,1);
			if (%fChar $= "/") {
				%dirNum++;
				
				// Drop a line and set the initial margin to indent.
				%newName = %newName @ "\n<lmargin:" @ ((%dirNum * 15)-3) @ ">";
				
				// Every time a "/" is encountered, add another folder picture.
				if (StrStr(GetSubStr(%fName,%i+1,Strlen(%fName)),"/") != -1)
					%newName = %newName @ "<bitmap:DDA_SubFolderPic> ";
				else
				// Otherwise, assume it's a filename and show that.
					%newName = %newName @ "<color:C0C0C0><lmargin:" @ ((%dirNum * 15)+12) @ ">";
			} else
				%newName = %newName @ %fChar;
		}
		
		return %newName;
	}
	
	
	// Updates the demo filename.
	function DEDDemoAdvanced::UpdateDemoFilename(%this) {
		// Formats the path and file text.
		%DemoFileName = DEDDemoAdvanced.AddTextFlavour(DEDDemoAdvanced.GenerateDemoFileName(0));
		
		// Sets the text to the options menu.
		DEDDemoAdvanced_FileNameText.setText("" @ %DemoFileName @ " ");
	}






//------------------------------------------------------------------------------------------	
// Sound support functions
//------------------------------------------------------------------------------------------
	// Plays a given wavefile from the gui directory.
	function DEDDemoAdvancedPlaySound(%wavFile) {
		%wavFile = "gui/" @ %wavFile @ ".wav";
		%sender = PlayerList.getMyID();
		%wavLengthMS = alxGetWaveLen(%wavFile);
		if ( $ClientChatHandle[%sender] != 0 )
			alxStop( $ClientChatHandle[%sender] );
					
		$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
		alxPlay( $ClientChatHandle[%sender] );
	}









//------------------------------------------------------------------------------------------	
// Snapshot functions
//------------------------------------------------------------------------------------------

	function DEDDemoAdvanced::ReplaceSnapshot() {
		if(isFile("textures/snapshots/" @ DEDDemoAdvanced.CurrentDemoFile @ ".png")) {
			if(deleteFile("textures/snapshots/" @ DEDDemoAdvanced.CurrentDemoFile @ ".png")) {
					// Do nothing.
			} else {
				echo("Error deleting snapshot");				
			}
		}

		%hudup = false;
		if(DDA_PlaybackDlg.isAwake()) {
			%hudup = true;
			Canvas.popDialog(DDA_PlaybackDlg);
		}

		DEDDemoAdvancedTakeSnapshot(DEDDemoAdvanced.CurrentDemoFile @ ".png");
		if (%hudup)
			Canvas.pushDialog(DDA_PlaybackDlg, 99);
	}

	function DEDDemoAdvancedTakeSnapshot(%val) {
		%valtwo = getSubStr(%val, 11, (strlen(%val) - 19));
		
		if (DEDDemoAdvanced.NoSnapShotHUDs) {
			Canvas.setContent(PanoramaGui);
			PanoramaGui.beaconsVisible = false;
			if ($cursorControlled) lockMouse(true);
			Canvas.cursorOff();
			Canvas.repaint();
		}

		$pref::interior::showdetailmaps = false;
		
		if (StrStr(%valtwo,"/") != -1) {
			%i = Strlen(%valtwo);
			while(%i > 0 && GetSubStr(%valtwo,%i,1) !$= "/") {
				%i--;
			}
		
			if (%i > 0) {
				%fileDir = "textures/snapshots/" @ GetSubStr(%valtwo,0,%i) @ "/";
				$DEDDemoAdvanced = new FileObject();
				$DEDDemoAdvanced.openForWrite(%fileDir);
				$DEDDemoAdvanced.close();
				$DEDDemoAdvanced.delete();
				$DEDDemoAdvanced = "";
			}	
		}

		$DemoFileSnapshot = "base/textures/snapshots/" @ %valtwo @ ".png";

		screenShot($DemoFileSnapshot);
		
		if (DEDDemoAdvanced.NoSnapShotHUDs)
			Canvas.setContent(PlayGui);
	}












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------


	function beginDemoRecord(){
		if(isDemo())
      			return;
      			
      		if(isRecordingDemo()) {
      			if (!DEDDemoAdvanced.ToggleSafetyMode) {
				if (DEDDemoAdvanced.SafetySound !$= "None" && DEDDemoAdvanced.EnableAudioAlerts)
					DEDDemoAdvancedPlaySound(DEDDemoAdvanced.SafetySound);

      				addMessageHudLine( "\c4Recording Safety Activated\cr");
      				DEDDemoAdvanced.ToggleSafetyMode = true;
     			}
      			
      			return;
      		}

	   	stopDemoRecord();

		if (DEDDemoAdvanced.Prompt) {	   	
			DEDDemoAdvanced.TempDemoFileName = DEDDemoAdvanced.GenerateDemoFileName(3);
			DEDDemoAdvancedFilenamePromptDlg_Edit.setText(DEDDemoAdvanced.TempDemoFileName);
			Canvas.pushdialog(DEDDemoAdvancedFilenamePromptDlg);
		} else {
			DEDDemoAdvanced.TempDemoFileName = DEDDemoAdvanced.GenerateDemoFileName(3);
			beginDemoRecordNextBit();
		}
	}
	
	function beginDemoRecordNextBit(){	
		if(isDemo())
      			return;

		if (!DEDDemoAdvanced.ToggleSafetyMode && DEDDemoAdvanced.AutomaticSafetyMode) {
			if (DEDDemoAdvanced.SafetySound !$= "None" && DEDDemoAdvanced.EnableAudioAlerts)
				DEDDemoAdvancedPlaySound(DEDDemoAdvanced.SafetySound);

      			addMessageHudLine( "\c4Recording Safety Activated\cr");
      			DEDDemoAdvanced.ToggleSafetyMode = true;
      		}

		$DemoFileName = DEDDemoAdvanced.GenerateDemoFileName(2) @ DEDDemoAdvanced.TempDemoFileName;
	   	
		DEDDemoAdvanced.Recording = true;
		if (DEDDemoAdvanced.StartSound !$= "None" && DEDDemoAdvanced.EnableAudioAlerts)
			DEDDemoAdvancedPlaySound(DEDDemoAdvanced.StartSound);
			
		if (DEDDemoAdvanced.ShowRecordHUD)
			DEDDemoAdvanced.ShowRecordingHud();
   			
		if (DEDDemoAdvanced.TakeSnapshots && DEDDemoAdvanced.SnapshotAt $= "Recording Start")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);

   		$DemoFile = "recordings/" @ $DemoFileName;

   		addMessageHudLine( "\c4Recording file: \c2" @ $DemoFileName @ "\cr");

   		saveDemoSettings();
   		startRecord($DemoFile);

   		// make sure start worked
   		if(!isRecordingDemo()) {
      			deleteFile($DemoFile);
      			deleteFile($DemoFileSnapshot);
      			addMessageHudLine( "\c3 *** Failed to record file: \c2" @ $DemoFileName @ "\cr");
      			DEDDemoAdvanced.Recording = false;
			DEDDemoAdvanced.HideRecordingHud();
			$DemoFile = "";
   		}
	}
	
	function doStopRecording() {
		DEDDemoAdvanced.HideRecordingHud();
   			
		if (DEDDemoAdvanced.StopSound !$= "None" && DEDDemoAdvanced.EnableAudioAlerts)
			DEDDemoAdvancedPlaySound(DEDDemoAdvanced.StopSound);
				
		if (DEDDemoAdvanced.TakeSnapshots && DEDDemoAdvanced.SnapshotAt $= "Map End")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);
   			
      		DEDDemoAdvanced.ToggleSafetyMode = false;
   		DEDDemoAdvanced.Recording = false;
      		stopRecord();
	}
	
	function stopDemoRecord() {
		if(isDemo())
  			return;
   		
   		if(isRecordingDemo()) {
			if (DEDDemoAdvanced.ToggleSafetyMode)
				messageBoxOkCancel("Stop Recording?", "Are you sure you wish to stop recording?", "doStopRecording();");
			else
				doStopRecording();
      		}
	}


	function demoRecordComplete() {
   		if($DemoFile !$= "") {
			if (DEDDemoAdvanced.TakeSnapshots && DEDDemoAdvanced.SnapshotAt $= "Recording End")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);
      			addMessageHudLine( "\c4Stopped recording file: \c2" @ $DemoFileName @ "\cr.");
      			DEDDemoAdvanced.LastDemoFileNumber++;
      			DEDDemoAdvanced.LastDemoFileName[DEDDemoAdvanced.LastDemoFileNumber] = $DemoFileName;
      			$DemoFile = "";
      			$DemoFileName = "";
   		}
	}










//---------------------------------------------------------------------
// Recording playback
//---------------------------------------------------------------------

	function StartSelectedDemo() {
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		if (getField(%rowText,2) !$= "   ") {
   			%file = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";

   			%verLen = getDemoVersionLength(%file);
   			DEDDemoAdvanced.CurrentDemoFile = %file;

   			Canvas.pushDialog(DemoLoadProgressDlg);
   		
   			if(playDemo(%file)) {
      				// do not allow new sources to have a force feedback effect
      				alxEnableForceFeedback(false);

      				resetGameState();
      				Canvas.popDialog(DemoLoadProgressDlg);
      				Canvas.popDialog(RecordingsDlg);   
      				Canvas.setContent(PlayGui);
      				loadDemoSettings();

      				$DemoPlaybackIndex = 1;
      				$DemoPlaybackLastIndex = 1;

				GlobalActionMap.bindCmd(keyboard, "escape", "", "stopDemoPlayback();");
				GlobalActionMap.bindCmd(keyboard, "tab", "", "toggleDemoPlaybackHud();");
				GlobalActionMap.bindCmd(keyboard, "space", "", "toggleDemoPause();");
				GlobalActionMap.bindCmd(keyboard, "numpadadd", "", "stepDemoPlaybackSpeed(1);");
				GlobalActionMap.bindCmd(keyboard, "numpadminus", "", "stepDemoPlaybackSpeed(-1);");
				GlobalActionMap.bindCmd(keyboard, "numpad0", "", "DEDDemoAdvancedReplaceSnapshot();");
				GlobalActionMap.bindCmd(keyboard, "numpadenter", "", "SetDemoSpeed(1);");
      				//$globalActionMapOnly = true;

      				$DemoPlaybackProgress = 0;
      				$DemoPlaybackLength = getField(%verLen, 1);
	
      				// playback length may be 0 if recording was not clean (just set to 1min)
      				if($DemoPlaybackLength == 0)
         				$DemoPlaybackLength = 60000;
      
	      			DemoPlayback_EndTime.setValue(msToMinSec($DemoPlaybackLength));
	
      				$DemoPlaybackProgress = 0;
	      			demoPlaybackUpdate(0);

      				updateDemoPlaybackStatus();
   			} else
      				MessageBoxOK("Playback Failed", "Demo playback failed for file '" @ %file @ "'.");

	   		Canvas.popDialog(DemoLoadProgressDlg);
	   	} else {
	   		%pname = getField(%rowText,3);

			DEDDemoAdvanced.CurrentPath = %pname;
			RecordingsDlg.fillRecordingsList();
			DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	   	}
	}

	function updateDemoPlaybackStatus() {
		if($DemoPlaybackIndex < -19)
			$DemoPlaybackIndex = -19;

		if($DemoPlaybackIndex > 20)
			$DemoPlaybackIndex = 20;

		if ($DemoPlaybackIndex <= 0) {
			%speedUsed = abs($DemoPlaybackIndex-2);
			%playbackSpeed = (1 / %speedUsed);
			%playbackText = "1 / " @ %speedUsed @ "X Speed";
			
			if ($DemoPlaybackIndex == -19) {
				%playbackSpeed = 0;
				%playbackText = "Paused";
			}
		} else {
			%playbackSpeed = $DemoPlaybackIndex;
			%playbackText = $DemoPlaybackIndex @ "X Speed";
		}

		DEDDemoAdvanced_CurSpeed.setValue(%playbackText);
		$timeScale = %playbackSpeed;
	}

	function demoPlaybackUpdate(%curTime) {
		parent::demoPlaybackUpdate(%curTime);		

		DDA_PlaybackProgressBar.setValue(%curTime / $DemoPlaybackLength);
		
		if (DEDDemoAdvanced.OutputtingScreenShots) {
			%convCurTime = msToMinSec(%curTime);
			if (!DEDDemoAdvanced.OutputLock) {
				if (%convCurTime $= DEDDemoAdvanced.OutputStartMatch) {
					echo("Started Outputting at " @ %convCurTime @ " = " @ DEDDemoAdvanced.OutputStartMatch);
					DEDDemoAdvanced.OutputFileText = DEDDemoAdvanced.FilterIllegalCharacters(DEDDemoAdvanced.OutputStartMatch) @ "-" @ DEDDemoAdvanced.FilterIllegalCharacters(DEDDemoAdvanced.OutputFinishMatch);
					DEDDemoAdvancedStartOutputtingScreens();
				}
			} else {
				if (%convCurTime $= DEDDemoAdvanced.OutputFinishMatch) {
					echo("Stopped Outputting at " @ %convCurTime @ " = " @ DEDDemoAdvanced.OutputFinishMatch);
					DEDDemoAdvancedStopDemoOutputting();
				}
			}
		}
	}

	function stopDemoPlayback() {
		GlobalActionMap.unbind(keyboard, "escape");
		$timeScale = 1;
		
		if (!$DDATMP::CurrentlyBatching) {
			GlobalActionMap.unbind(keyboard, "tab");
			GlobalActionMap.unbind(keyboard, "space");
			GlobalActionMap.unbind(keyboard, "numpadadd");
			GlobalActionMap.unbind(keyboard, "numpadminus");
			GlobalActionMap.unbind(keyboard, "numpad0");
			GlobalActionMap.unbind(keyboard, "numpadenter");
		}

		cancel($screenGrabThread);
		if(DEDDemoAdvanced.OutputLock){
			DEDDemoAdvanced.OutputLock = false;
			if (DEDDemoAdvanced.OutputMuteSounds) {
				$pref::Audio::masterVolume = DEDDemoAdvanced.PreviousVolume;
				alxListenerf( AL_GAIN_LINEAR, $pref::Audio::masterVolume );
			}

			if (DEDDemoAdvanced.ShowCurrentGamma)
				videoSetGammaCorrection( $pref::OpenGL::gammaCorrection );

			// playsound for demo finish
		}
		DEDDemoAdvanced.OutputtingScreenShots = false;
		
		parent::stopDemoPlayback();
		if ($DDATMP::CurrentlyBatching && !$DDATMP::Exit) {
			$DDATMP::CurrentBatchFile++;
			schedule(10000,0,"DEDDemoAdvanced_StartNextDemoInBatch");
		}
	}
	
	function SetDemoSpeed(%val) {
		$DemoPlaybackIndex = %val;
	}







//------------------------------------------------------------------------------------------
// Recording Loading Screen Functions
//------------------------------------------------------------------------------------------
	// When the DemoLoadProgressDlg bar wakes.
	function DemoLoadProgressDlg::onWake(%this){
		parent::onWake(%this);
		
		// Separate the x and y resolution values.
		%px = firstWord($pref::Video::resolution);
		%py = getWord($pref::Video::resolution, 1);

		// Set the size of the dialogs based on the screen resolution.
		DemoLoadProgressDlg.setExtent(%px, %py);
		DEDDemoAdvancedLoadingPicture.setExtent(%px, %py);
		DEDDemoAdvancedLoadingName.setExtent(mfloor((%px / 1024) * 600), mfloor((%py / 768) * 80));
		
		// Alter the loading dialogs based on whether or not there's a snapshot.
		if ($DDATemp::LoadingPic $= "") {
			DemoLoadProgressCtrl.setPosition(mfloor((%px / 1024) * 25), mfloor((%py/2)));
			DemoLoadProgressCtrl.setExtent(mfloor(%px - ((%px / 1024) * 50)), mfloor((%py / 768) * 30));
			DDA_BigLoadingTextProfile.setPosition(mfloor((%px / 2) - ((%px/1024) * 50)), mfloor((%py / 2)));
		} else {
			DemoLoadProgressCtrl.setPosition(mfloor((%px / 1024) * 5), (mfloor(%py/768) * 733));
			DemoLoadProgressCtrl.setExtent(mfloor(%px - ((%px / 1024) * 10)), mfloor((%py / 768) * 30));
			DDA_BigLoadingTextProfile.setPosition(mfloor((%px / 2) - ((%px/1024) * 50)), mfloor((%py / 768) * 733));
		}
	}





//------------------------------------------------------------------------------------------
// Generic GUI Functions
//------------------------------------------------------------------------------------------
	// Sets the cursor on
	function DEDDemoAdvanced::MouseShow(%this) {
		DEDDemoAdvanced.LastMouseState = Canvas.isCursorOn();
		if(!DEDDemoAdvanced.LastMouseState)
			CursorOn();
	}


	// Sets the cursor off
	function DEDDemoAdvanced::MouseHide(%this) {
		if(!DEDDemoAdvanced.LastMouseState)
			CursorOff();
	}


//------------------------------------------------------------------------------------------	
// Options menu
//------------------------------------------------------------------------------------------
	// Shows the options menu.
	function DEDDemoAdvanced::ShowOptions(%this) {
		Canvas.pushDialog(DEDDemoAdvancedConfigGUI);
		DEDDemoAdvancedConfigGUI.Shown = true;
	}


	// Hide the options menu.
	function DEDDemoAdvanced::HideOptions(%this) {
		Canvas.popDialog(DEDDemoAdvancedConfigGUI);
		
		DEDDemoAdvancedConfigGUI.Shown = false;
		canvas.repaint();
	}


	// Toggles the load menu on or off, showing and hiding it as necessary.
	function DEDDemoAdvanced::ToggleOptions(%this) {
		if (!DEDDemoAdvancedConfigGUI.Shown) {
			DEDDemoAdvanced.ShowOptions();
			DEDDemoAdvanced.MouseShow();
		} else {
			DEDDemoAdvanced.HideOptions();
			DEDDemoAdvanced.MouseHide();
		}			
	}




	function DDA_TabView::onAdd( %this ) {
		%this.addSet( 1, "gui/shll_horztabbuttonB", "5 5 5", "50 50 0", "5 5 5" );
	}

	function DDA_TabView::onSelect(%this, %id, %text) {
		DDA_NamingPane.setVisible(%id == 1);
		DDA_RecordingPane.setVisible(%id == 2);
		DDA_AudioPane.setVisible(%id == 3);
	}

	function DEDDemoAdvancedConfigGUI::onWake(%this) {
		if (DDA_TabView.tabCount() == 0) {
       			DDA_TabView.addTab( 1, "NAMING" );
			DDA_TabView.addTab( 2, "RECORDING" );
			DDA_TabView.addTab( 3, "AUDIO ALERTS" );
   		}

		switch$ ( %this.pane ) {
			case "Audio Alerts":
				DDA_TabView.setSelected( 3 );
			case "Recording":
				DDA_TabView.setSelected( 2 );
			default:
				DDA_TabView.setSelected( 1 );
   		}
	
		DEDDemoAdvancedTextPrefixBtn.setValue(DEDDemoAdvanced.TextPrefix);
		DEDDemoAdvancedPlayerNameBtn.setValue(DEDDemoAdvanced.PlayerName);
		DEDDemoAdvancedServerNameBtn.setValue(DEDDemoAdvanced.ServerName);
		DEDDemoAdvancedMissionNameBtn.setValue(DEDDemoAdvanced.MissionName);
		DEDDemoAdvancedGameTypeBtn.setValue(DEDDemoAdvanced.GameType);
		DEDDemoAdvancedTeamNameBtn.setValue(DEDDemoAdvanced.TeamName);
		DEDDemoAdvancedServerModNameBtn.setValue(DEDDemoAdvanced.ServerModName);
		
		DEDDemoAdvancedTextPrefixDirBtn.setValue(DEDDemoAdvanced.TextPrefixDir);
		DEDDemoAdvancedPlayerNameDirBtn.setValue(DEDDemoAdvanced.PlayerNameDir);
		DEDDemoAdvancedServerNameDirBtn.setValue(DEDDemoAdvanced.ServerNameDir);
		DEDDemoAdvancedMissionNameDirBtn.setValue(DEDDemoAdvanced.MissionNameDir);
		DEDDemoAdvancedGameTypeDirBtn.setValue(DEDDemoAdvanced.GameTypeDir);
		DEDDemoAdvancedTeamNameDirBtn.setValue(DEDDemoAdvanced.TeamNameDir);
		DEDDemoAdvancedServerModNameDirBtn.setValue(DEDDemoAdvanced.ServerModDirName);

		DEDDemoAdvancedPromptBtn.setValue(DEDDemoAdvanced.Prompt);
		DEDDemoAdvancedAutomaticSafetyModeBtn.setValue(DEDDemoAdvanced.AutomaticSafetyMode);
		DEDDemoAdvancedAlwaysRecordTournamentsBtn.setValue (DEDDemoAdvanced.AlwaysRecordTournaments );
		DEDDemoAdvancedShowRecordBtn.setValue(DEDDemoAdvanced.ShowRecordHUD);
		DEDDemoAdvancedShowRecordBlinkBtn.setValue(DEDDemoAdvanced.ShowRecordHUDBlink);
		DEDDemoAdvancedRecordOnMapStartBtn.setValue(DEDDemoAdvanced.RecordOnMapStart);
		DEDDemoAdvancedStopAtMapEndBtn.setValue(DEDDemoAdvanced.StopAtMapEnd);
		DEDDemoAdvancedShowScoresBtn.setValue(DEDDemoAdvanced.ShowScores);
		DEDDemoAdvancedTakeSnapshotsBtn.setValue(DEDDemoAdvanced.TakeSnapshots);
		DEDDemoAdvancedNoSnapshotHUDsBtn.setValue(DEDDemoAdvanced.NoSnapShotHUDs);
		DEDDemoAdvancedSelectTakeSnapshotsBtn.setValue( DEDDemoAdvanced.SnapshotAt);
		
		DEDDemoAdvanced_RecordingHudSize.setValue( DEDDemoAdvanced.RecordingHudSize );
		
		DEDDemoAdvanced.RecordingHudX = mFloor(42 * DEDDemoAdvanced.RecordingHudSize) -1;
		DEDDemoAdvanced.RecordingHudY = mFloor(25 * DEDDemoAdvanced.RecordingHudSize) -1;
		
		DEDDemoAdvancedOnIcon.setExtent(DEDDemoAdvanced.RecordingHudX, DEDDemoAdvanced.RecordingHudY);

		// Audio stuff
		DEDDemoAdvancedSelectDeleteSoundBtnFiller();
		DEDDemoAdvancedSelectSafetySoundBtnFiller();
		DEDDemoAdvancedSelectStartSoundBtnFiller();
		DEDDemoAdvancedSelectStopSoundBtnFiller();
		DEDDemoAdvancedSelectStartRecordBtnFiller();
		DEDDemoAdvancedSelectTakeSnapshotsBtnFiller();
		
		DEDDemoAdvancedEnableAudioAlertsBtn.setValue(DEDDemoAdvanced.EnableAudioAlerts);
		DEDDemoAdvancedToggleAudioAlerts();
		
		DEDDemoAdvanced.UpdateDemoFilename();
	}
	
	function DEDDemoAdvancedToggleAudioAlerts() {
		if (DEDDemoAdvanced.EnableAudioAlerts) {
			DEDDemoAdvancedSelectStartSoundBtn.setActive(true);
			DEDDemoAdvancedSelectStopSoundBtn.setActive(true);
			DEDDemoAdvancedSelectDeleteSoundBtn.setActive(true);
			DEDDemoAdvancedSelectSafetySoundBtn.setActive(true);
			
			if (DEDDemoAdvancedSelectStartSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestStartSoundBtn.setActive(true);


			if (DEDDemoAdvancedSelectStopSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestStopSoundBtn.setActive(true);

			
			if (DEDDemoAdvancedSelectDeleteSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestDeleteSoundBtn.setActive(true);
				
				
			if (DEDDemoAdvancedSelectSafetySoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestSafetySoundBtn.setActive(true);

		} else {
			DEDDemoAdvancedSelectStartSoundBtn.setActive(false);
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStopSoundBtn.setActive(false);
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			DEDDemoAdvancedSelectDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedSelectSafetySoundBtn.setActive(false);
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
		}
	}
	
	function DEDDemoAdvancedConfigGUI::onDeactivate(%this) {
		DEDDemoAdvanced.SavePrefs();
	}

	function DEDDemoAdvancedConfigGUI::onSleep(%this) {
		DEDDemoAdvanced.SavePrefs();
	}

	function DDA_OutputPanoramaViewBtn::CheckOtherButtons(%this) {
		if (DEDDemoAdvanced.OutputPanorama)
			%cl = false;
		else
			%cl = true;

		DDA_OutputShowTargetsBtn.setActive(%cl);
		DDA_OutputShowClientHUDSBtn.setActive(%cl);
		DDA_OutputShowPotentialTaskBtn.setActive(%cl);
		DDA_OutputShowAssignedTaskBtn.setActive(%cl);
		DDA_OutputShowClientWaypointBtn.setActive(%cl);
		DDA_OutputShowMissionWaypointBtn.setActive(%cl);
		DDA_OutputShowBeaconsBtn.setActive(%cl);
	}

	function DDA_OutputPanoramaViewBtn::onAction(%this) {
		DEDDemoAdvanced.OutputPanorama = %this.getValue();
		DDA_OutputPanoramaViewBtn.CheckOtherButtons();
	}


	function DDA_OutputShowClientHUDSBtn::onAction(%this) {
		DEDDemoAdvanced.OutputHUDS = %this.getValue();
	}

	function DDA_OutputShowTargetsBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowTargets = %this.getValue();
	}


	function DDA_OutputShowPotentialTaskBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowPotentialTask = %this.getValue();
	}

	function DDA_OutputShowAssignedTaskBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowAssignedTask = %this.getValue();
	}

	function DDA_OutputShowClientWaypointBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowClientWaypoint = %this.getValue();
	}
	
	function DDA_OutputShowMissionWaypointBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowMissionWaypoint = %this.getValue();
	}

	function DDA_OutputShowBeaconsBtn::onAction(%this) {
		DEDDemoAdvanced.OutputShowBeacons = %this.getValue();
	}
	
	function DEDDemoAdvancedOutputMuteSoundsBtn::onAction(%this) {
		DEDDemoAdvanced.OutputMuteSounds = %this.getValue();
	}

	


	function DEDDemoAdvancedGameOver() {
		DEDDemoAdvanced.TournamentModeCheck = false;
		if (DEDDemoAdvanced.StopAtMapEnd && !isDemo() && isRecordingDemo()) {
			if (!DEDDemoAdvanced.ShowScores) {
				doStopRecording();
			} else {
				schedule( 1000, 0, "doStopRecording" );
			}
		}
	}

	function clientCmdPickTeamMenu( %teamA, %teamB ) {
		parent::clientCmdPickTeamMenu(%teamA, %teamB);
		DEDDemoAdvanced.TournamentModeCheck = true;
	}

	
	function DEDDemoAdvancedMissionStart(%msgType, %msgString) {
		if (!isDemo() && !isRecordingDemo() && (DEDDemoAdvanced.RecordOnMapStart || (DEDDemoAdvanced.AlwaysRecordTournaments && DEDDemoAdvanced.TournamentModeCheck))) {
			if (DEDDemoAdvanced.TakeSnapshots && DEDDemoAdvanced.SnapshotAt $= "Map Start")
				DEDDemoAdvanced.ReplaceSnapshot();

			beginDemoRecord();
		}
		DEDDemoAdvanced.TournamentModeCheck = false;
	}

	function DEDDemoAdvancedEnableAudioAlertsBtn::onAction(%this) {
		DEDDemoAdvanced.EnableAudioAlerts = %this.getValue();
		DEDDemoAdvancedToggleAudioAlerts();
	}
	
	function DEDDemoAdvancedTextPrefixBtn::onAction(%this) {
		DEDDemoAdvanced.TextPrefix = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}
	
	function DEDDemoAdvancedPlayerNameBtn::onAction(%this) {
		DEDDemoAdvanced.PlayerName = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedServerNameBtn::onAction(%this) {
		DEDDemoAdvanced.ServerName = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedServerModNameBtn::onAction(%this) {
		DEDDemoAdvanced.ServerModName = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedMissionNameBtn::onAction(%this) {
		DEDDemoAdvanced.MissionName = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}
	
	function DEDDemoAdvancedGameTypeBtn::onAction(%this) {
		DEDDemoAdvanced.GameType = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}			

	function DEDDemoAdvancedTeamNameBtn::onAction(%this) {
		DEDDemoAdvanced.TeamName = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}			

	function DEDDemoAdvancedTextPrefixDirBtn::onAction(%this) {
		DEDDemoAdvanced.TextPrefixDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedPlayerNameDirBtn::onAction(%this) {
		DEDDemoAdvanced.PlayerNameDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedServerNameDirBtn::onAction(%this) {
		DEDDemoAdvanced.ServerNameDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedServerModNameDirBtn::onAction(%this) {
		DEDDemoAdvanced.ServerModNameDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}

	function DEDDemoAdvancedMissionNameDirBtn::onAction(%this) {
		DEDDemoAdvanced.MissionNameDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}
	
	function DEDDemoAdvancedGameTypeDirBtn::onAction(%this) {
		DEDDemoAdvanced.GameTypeDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}			

	function DEDDemoAdvancedTeamNameDirBtn::onAction(%this) {
		DEDDemoAdvanced.TeamNameDir = %this.getValue();
		DEDDemoAdvanced.UpdateDemoFilename();
	}			
	
	function DEDDemoAdvancedShowRecordBtn::onAction(%this) {
		DEDDemoAdvanced.ShowRecordHUD = %this.getvalue();
		if (DEDDemoAdvanced.ShowRecordHUD)
			if (DEDDemoAdvanced.Recording)
				DEDDemoAdvanced.ShowRecordingHud();
		else {
			if (DEDDemoAdvanced.Recording)
				DEDDemoAdvanced.HideRecordingHud();
		}
	}


	function DEDDemoAdvancedShowRecordBlinkBtn::onAction(%this) {
		DEDDemoAdvanced.ShowRecordHUDBlink = %this.getValue();
		if (DEDDemoAdvanced.ShowRecordHUDBlink && DEDDemoAdvanced.Recording)
			DEDDemoAdvanced_FlashRecordingHud();
	}
	
	
	function DEDDemoAdvancedPromptBtn::onAction(%this) {
		DEDDemoAdvanced.Prompt = %this.getValue();
	}


	function DEDDemoAdvancedAutomaticSafetyModeBtn::onAction(%this) {
		DEDDemoAdvanced.AutomaticSafetyMode = %this.getValue();
	}


	function DEDDemoAdvancedRecordOnMapStartBtn::onAction(%this) {
		DEDDemoAdvanced.RecordOnMapStart = %this.getValue();
	}
	
	function DEDDemoAdvancedStopAtMapEndBtn::onAction(%this) {
		DEDDemoAdvanced.StopAtMapEnd = %this.getValue();
	}
	
	function DEDDemoAdvancedAlwaysRecordTournamentsBtn::onAction(%this) {
		DEDDemoAdvanced.AlwaysRecordTournaments = %this.getValue();
	}
	
	function DEDDemoAdvancedShowScoresBtn::onAction(%this) {
		DEDDemoAdvanced.ShowScores = %this.getValue();
	}
	
	function DEDDemoAdvancedTakeSnapshotsBtn::onAction(%this) {
		DEDDemoAdvanced.TakeSnapshots = %this.getValue();
	}
	
	function DEDDemoAdvancedNoSnapshotHUDsBtn::onAction(%this) {
		DEDDemoAdvanced.NoSnapShotHUDs = %this.getValue();
	}


	function DEDDemoAdvancedSelectTakeSnapshotsBtnFiller() {
		DEDDemoAdvancedSelectTakeSnapshotsBtn.clear();
		
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Map Start", 0, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Map End", 1, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Recording Start", 2, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Recording End", 3, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Output Start", 4, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Output End", 5, 1 );

		switch$ ( DEDDemoAdvanced.SnapshotAt ) {
			case "Map Start": %ct = 0;
			case "Map End": %ct = 1;
			case "Recording Start": %ct = 2;
			case "Recording End": %ct = 3;
			case "Output Start": %ct = 4;
			case "Output End": %ct = 5;
			default: %ct = 0;
   		}

		DEDDemoAdvancedSelectTakeSnapshotsBtn.setSelected(%ct);
 	}

	function DEDDemoAdvancedSelectTakeSnapshotsBtn::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.SnapshotAt = DEDDemoAdvancedSelectTakeSnapshotsBtn.getValue();
	}


	function DEDDemoAdvancedSelectStartSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectStartSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestStartSoundBtn.setActive(true);
		
		DEDDemoAdvanced.StartSound = "DDA_" @ DEDDemoAdvancedSelectStartSoundBtn.getValue() @ "_On";
	}
	
	function DEDDemoAdvancedSelectStartSoundBtnFiller() {
		DEDDemoAdvancedSelectStartSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_On.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectStartSoundBtn.add("None", 0, 1 );
		%ct = 1;
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 7));

			DEDDemoAdvancedSelectStartSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= DEDDemoAdvanced.StartSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStartSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStartSoundBtn.setSelected(0);
		}
 	}

 	function DEDDemoAdvancedSelectDeleteSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectDeleteSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(true);
 		
		DEDDemoAdvanced.DeleteSound = "DDA_" @ DEDDemoAdvancedSelectDeleteSoundBtn.getValue() @ "_Del";
	}

 	function DEDDemoAdvancedSelectSafetySoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectSafetySoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestSafetySoundBtn.setActive(true);
 		
		DEDDemoAdvanced.SafetySound = "DDA_" @ DEDDemoAdvancedSelectSafetySoundBtn.getValue() @ "_Saf";
	}
 	
 	function DEDDemoAdvancedSelectStopSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectStopSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestStopSoundBtn.setActive(true);
 		
		DEDDemoAdvanced.StopSound = "DDA_" @ DEDDemoAdvancedSelectStopSoundBtn.getValue() @ "_Off";
	}

	function DEDDemoAdvancedSelectSafetySoundBtnFiller() {
		DEDDemoAdvancedSelectSafetySoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Saf.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectSafetySoundBtn.add("None", 0, 1 );
		%ct = 1;

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectSafetySoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= DEDDemoAdvanced.SafetySound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectSafetySoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
			DEDDemoAdvancedSelectSafetySoundBtn.setSelected(0);
		}
 	}

	function DEDDemoAdvancedSelectDeleteSoundBtnFiller() {
		DEDDemoAdvancedSelectDeleteSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Del.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectDeleteSoundBtn.add("None", 0, 1 );
		%ct = 1;

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectDeleteSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= DEDDemoAdvanced.DeleteSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectDeleteSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedSelectDeleteSoundBtn.setSelected(0);
		}
 	}

	
	function DEDDemoAdvancedSelectStopSoundBtnFiller() {
		DEDDemoAdvancedSelectStopSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Off.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectStopSoundBtn.add("None", 0, 1 );
		%ct = 1;
		
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectStopSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= DEDDemoAdvanced.StopSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStopSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStopSoundBtn.setSelected(0);
		}
 	}

	function DEDDemoAdvancedSelectStartRecordBtn::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.StartRecord = "DDA_" @ DEDDemoAdvancedSelectStartRecordBtn.getValue() @ "_On";
	}
	
	function DEDDemoAdvancedSelectStartRecordBtnFiller() {
		DEDDemoAdvancedSelectStartRecordBtn.clear();
		
		%search = "textures/gui/DDA_*_On.png";
		
		%findSelected = -1;
		%ct = 0;
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 7));

			DEDDemoAdvancedSelectStartRecordBtn.add( %entry, %ct, 1 );
			if (%fileName $= DEDDemoAdvanced.StartRecord) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStartRecordBtn.setSelected(%findSelected);
		else
			DEDDemoAdvancedSelectStartRecordBtn.setSelected(0);
 	}



	function DDA_PlaybackDlg::onWake(%this) {
   		if(!Canvas.isCursorOn())
			schedule(4,0,"CursorOn");

		updateDemoPlaybackStatus();
	}

 	function toggleDemoPause() {
		if ($DemoPlaybackIndex == -19) {
			DEDDemoAdvanced.Paused = false;
			$DemoPlaybackIndex = $DemoPlaybackLastIndex;
		} else {
			DEDDemoAdvanced.Paused = true;
			$DemoPlaybackLastIndex = $DemoPlaybackIndex;
			$DemoPlaybackIndex = -19;
		}

		if ($DemoPlaybackIndex == -19) {
			DDA_PlaybackPlayBtn.setVisible(false);
			DDA_PlaybackPausedBtn.setVisible(true);
		} else {
			DDA_PlaybackPlayBtn.setVisible(true);
			DDA_PlaybackPausedBtn.setVisible(false);
		}

		updateDemoPlaybackStatus();
	}

 	
 	function stepDemoPlaybackSpeed(%step) {
 		if (DEDDemoAdvanced.Paused) {
 			DEDDemoAdvanced.Paused = false;
			$DemoPlaybackIndex = $DemoPlaybackLastIndex;
		} else {
   			$DemoPlaybackIndex += %step;
   		}
   		
   		DEDDemoAdvanced_CurSpeed.setValue($DemoPlaybackIndex);
		updateDemoPlaybackStatus();
	}
	

	function ScriptBrowserGui::onSleep(%this) {
		DEDDemoAdvanced.SavePrefs();
		parent::onSleep(%this);
	}

	function minSecToms(%time) {
		if (GetSubStr(%time,0,1) $= "0") 
			%min = GetSubStr(%time,1,1);
		else
			%min = GetSubStr(%time,0,2);
			
		if (GetSubStr(%time,3,1) $= "0")
			%sec = GetSubStr(%time,4,1);
		else
			%sec = GetSubStr(%time,3,2);
		
		return(((%min * 60) + %sec) * 1000);
	}

	function OutputSelectedDemoDlg::onSleep(%this) {
		DEDDemoAdvanced.SavePrefs();
	}


	function DEDDemoAdvanced::GetSecondsFromTime(%this, %timeStr) {
		%pos = strpos(%timeStr, ":") + 1;
		%seconds = getSubStr(%timeStr, %pos, strlen(%timeStr) - %pos);

		return %seconds;
	}

	
	function DEDDemoAdvanced::GetMinutesFromTime(%this, %timeStr) {
		%minute = getSubStr(%timeStr, 0, strpos(%timeStr, ":"));

		return %minute;
	}


	function DDA_OutputStartTimeMinuteDropDown::fillList() {
		DDA_OutputStartTimeMinuteDropDown.clear();
		
		%minute = DEDDemoAdvanced.OutputStartTimeMinute;
		
		//if (DEDDemoAdvanced.OutputStartTimeMinute >= DEDDemoAdvanced.OutputFinishTimeMinute)
		if (DEDDemoAdvanced.OutputFinishTimeMinute < DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength))
			%maxmin = DEDDemoAdvanced.OutputFinishTimeMinute;
		else 
			%maxmin = DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength);
	
		%minmin = DEDDemoAdvanced.OutputStartTimeMinuteMinimum;
	
		for (%i = %minmin; %i <= %maxmin; %i++) {
			%val = %i;
			if (%val < 10)
				%val = "0" @ %val;

			DDA_OutputStartTimeMinuteDropDown.add(%val,%i);
		}

		if (%minute < %minmin)
			%minute = %minmin;
			
		if (%minute > %maxmin)
			%minutes = %maxmin;

		DEDDemoAdvanced.OutputStartTimeMinute = %minute;
		
		DDA_OutputStartTimeMinuteDropDown.setSelected(%minute);
	}


	function DDA_OutputStartTimeSecondDropDown::fillList() {
		DDA_OutputStartTimeSecondDropDown.clear();

		%second = DEDDemoAdvanced.OutputStartTimeSecond;
		
		// If the current start minute set is equal to the maximum number of minutes
		if (DEDDemoAdvanced.OutputStartTimeMinute == DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength))
			// set the maximum number of seconds to the seconds column of the maximum time.
			%maxsec = DEDDemoAdvanced.GetSecondsFromTime(DEDDemoAdvanced.DemoOutputLength);
			
		// Otherwise, if the start minute is the same as the finish minute, set the maximum
		// number of seconds to the current seconds setting of the finish time.
		else if (DEDDemoAdvanced.OutputStartTimeMinute == DEDDemoAdvanced.OutputFinishTimeMinute)
			%maxsec = DEDDemoAdvanced.OutputFinishTimeSecond;
			
		// Otherwise, the seconds can go up to 59.
		else
			%maxsec = 59;
		
		if (DEDDemoAdvanced.OutputStartTimeMinute == DEDDemoAdvanced.OutputStartTimeMinuteMinimum)
			%minsec = DEDDemoAdvanced.OutputStartTimeSecondMinimum;
		else
			%minsec = 0;

		for (%i = %minsec; %i <= %maxsec; %i++) {
			%val = %i;
			if (%val < 10)
				%val = "0" @ %val;

			DDA_OutputStartTimeSecondDropDown.add(%val,%i);
		}

		if (%second < %minsec)
			%second = %minsec;
			
		if (%second > %maxsec)
			%second = %maxsec;

		DEDDemoAdvanced.OutputStartTimeSecond = %second;

		DDA_OutputStartTimeSecondDropDown.setSelected(%second);
	}


	function DDA_OutputFinishTimeMinuteDropDown::fillList() {
		DDA_OutputFinishTimeMinuteDropDown.clear();
		
		%minute = DEDDemoAdvanced.OutputFinishTimeMinute;
		%maxmin = DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength);
		%minmin = DEDDemoAdvanced.OutputStartTimeMinute;

		for (%i = %minmin; %i <= %maxmin; %i++) {
			%val = %i;
			if (%val < 10)
				%val = "0" @ %val;

			DDA_OutputFinishTimeMinuteDropDown.add(%val,%i);
		}
		
		if (%minute < %minmin)
			%minute = %minmin;
			
		if (%minute > %maxmin)
			%minutes = %maxmin;

		DEDDemoAdvanced.OutputFinishTimeMinute = %minute;
		
		DDA_OutputFinishTimeMinuteDropDown.setSelected(%minute);
	}


	function DDA_OutputFinishTimeSecondDropDown::fillList() {
		DDA_OutputFinishTimeSecondDropDown.clear();

		%second = DEDDemoAdvanced.OutputFinishTimeSecond;

		if (DEDDemoAdvanced.OutputFinishTimeMinute == DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength))
			%maxsec = DEDDemoAdvanced.GetSecondsFromTime(DEDDemoAdvanced.DemoOutputLength);
		else
			%maxsec = 59;
			
		if (DEDDemoAdvanced.OutputFinishTimeMinute == DEDDemoAdvanced.OutputStartTimeMinute)
			%minsec = DEDDemoAdvanced.OutputStartTimeSecond;
		else
			%minsec = 0;
		
		for (%i = %minsec; %i <= %maxsec; %i++) {
			%val = %i;
			if (%val < 10)
				%val = "0" @ %val;

			DDA_OutputFinishTimeSecondDropDown.add(%val,%i);
		}

		if (%second < %minsec)
			%second = %minsec;
			
		if (%second > %maxsec)
			%second = %maxsec;

		DEDDemoAdvanced.OutputFinishTimeSecond = %second;
		
		DDA_OutputFinishTimeSecondDropDown.setSelected(%second);
	}


	function DDA_OutputStartTimeMinuteDropDown::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.OutputStartTimeMinute = %id;
		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
	}

	function DDA_OutputStartTimeSecondDropDown::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.OutputStartTimeSecond = %id;
		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
	}


	function DDA_OutputFinishTimeMinuteDropDown::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.OutputFinishTimeMinute = %id;
		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
	}

	function DDA_OutputFinishTimeSecondDropDown::onSelect( %this, %id, %text ) {
		DEDDemoAdvanced.OutputFinishTimeSecond = %id;
		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
	}

	function DEDDemoAdvanced::RebuildOutputTimeDropDowns(%this) {
		DDA_OutputStartTimeMinuteDropDown.fillList();
		DDA_OutputStartTimeSecondDropDown.fillList();
		DDA_OutputFinishTimeMinuteDropDown.fillList();
		DDA_OutputFinishTimeSecondDropDown.fillList();
	}






//------------------------------------------------------------------------------------------
// Task List Pop-Up Menu Functions
//------------------------------------------------------------------------------------------
	// Whenever the playlist is added...
	function DDABatchList::onAdd( %this ) {
		// If the DDABatchListPopUpDlg object already exists, delete it.
		if (isObject(DDABatchListPopUpDlg)) {
			DDABatchListPopupDlg.delete();
		}

		// Create the new DEDAmpPlayListDlgPopUpDlg object.
		new GuiControl(DDABatchListPopupDlg) {
			profile = "PopUpDlgProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			setFirstResponder = "0";
			modal = "1";

			// The playlist pop-up menu.
			new ShellPopupMenu(DDABatchListPopup) {
				profile = "ShellPopupProfile";
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = "1";
				maxPopupHeight = "200";
				noButtonStyle = "1";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
			};
		};
	}

	function DDABatchListPopupDlg::onCancel(%this) {
		echo("woo");
	}

	// Whenever the DDABatchListPopupDlg wakes...
	function DDABatchListPopupDlg::onWake(%this) {
		// Clear the pop-up.
		DDABatchListPopup.clear();

		// Add options to the pop-up.
		//DDABatchListPopup.add("Edit", 0);
		DDABatchListPopup.add("Clear List", 1);

		Canvas.rePaint();
	}


	// Whenever an option on the list pop-up is selected...
	function DDABatchListPopup::onSelect( %this, %id, %text ) {
		// Determine which option was chosen...
		switch ( %id ) {
			case 0: // Play
				//
				
			case 1: // Clear List
				DEDDemoAdvanced.NumBatchList = 0;
				DEDDemoAdvanced.BatchList[DEDDemoAdvanced.NumBatchList] = "";
				$DDATMP::BatchTimeList[$DDATMP::BatchFileCount] = "";
				DEDDemoAdvanced.RebuildOutputTimeDropDowns();
				OutputSelectedDemoDlg.fillList();
		}

		// Close the pop-up.
		Canvas.popDialog(DDABatchListPopupDlg);
	}


	// Whenever the playlist is right-clicked on.
	function DDABatchList::onRightMouseDown(%this, %column, %row, %mousePos) {  
		DDABatchList.setSelectedRow(%row);

		// Open the pop-up menu.
		Canvas.pushDialog(DDABatchListPopupDlg);
			
		// Determine the position of the pop-up menu relative to the mouse.
		%mx = getWord(%mousePos, 0);
		%my = getWord(%mousePos, 1);
		%mx = %mx - 10;
		%my = %my + 3;
			
		%newPos = %mx @ " " @ %my;
			
		// Set the pop-up menu properties.
		DDABatchListPopup.position = %newPos;
		DDABatchListPopupDlg.onWake();
		DDABatchListPopup.forceOnAction();
	}










	
	function OutputSelectedDemoDlg::onWake(%this) {
		if (!isDemo()) {
			%sel = RecordingsDlgList.getSelectedId();
  			%rowText = RecordingsDlgList.getRowTextById(%sel);

			%fileName = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";
		
	   		DEDDemoAdvanced.DemoOutputLength = getField(%rowText,2);
			
		} else {
			%version = getDemoVersion();
			%val = getDemoVersionLength(DEDDemoAdvanced.CurrentDemoFile);
			
			if(%version == -1) {
				%version = "???";
				%length = "???";
			} else
        			%length = msToMinSec(getField(%val, 1));

			DEDDemoAdvanced.DemoOutputLength = %length;
			%time = DemoPlayback_CurTime.getValue();
		}

		DDA_OutputPanoramaViewBtn.setValue(DEDDemoAdvanced.OutputPanorama);
		DDA_OutputShowClientHUDSBtn.setValue(DEDDemoAdvanced.OutputHUDS);
		DDA_OutputShowTargetsBtn.setValue(DEDDemoAdvanced.OutputShowTargets);
		DDA_OutputShowPotentialTaskBtn.setValue(DEDDemoAdvanced.OutputShowPotentialTask);
		DDA_OutputShowAssignedTaskBtn.setValue(DEDDemoAdvanced.OutputShowAssignedTask);
		DDA_OutputShowClientWaypointBtn.setValue(DEDDemoAdvanced.OutputShowClientWaypoint);
		DDA_OutputShowMissionWaypointBtn.setValue(DEDDemoAdvanced.OutputShowMissionWaypoint);
		DDA_OutputShowBeaconsBtn.setValue(DEDDemoAdvanced.OutputShowBeacons);
		DDA_OutputPanoramaViewBtn.CheckOtherButtons();

		DEDDemoAdvanced.OutputStartTimeMinute = 0;
		DEDDemoAdvanced.OutputStartTimeSecond = 0;
		DEDDemoAdvanced.OutputFinishTimeMinute = DEDDemoAdvanced.GetMinutesFromTime(DEDDemoAdvanced.DemoOutputLength);
		DEDDemoAdvanced.OutputFinishTimeSecond = DEDDemoAdvanced.GetSecondsFromTime(DEDDemoAdvanced.DemoOutputLength);

		DEDDemoAdvanced.RebuildOutputTimeDropDowns();
		DEDDemoAdvanced.DemoOutputLengthMS = minSecToms(DEDDemoAdvanced.DemoOutputLength);
		DDA_OutputFPSSlider.setValue(DEDDemoAdvanced.FPS);
		
		DDA_CreateBatchFileBtn.setValue(DEDDemoAdvanced.OutputBatchFile);
		DEDDemoAdvancedOutputMuteSoundsBtn.setValue(DEDDemoAdvanced.OutputMuteSounds);
		
		%this.fillList();
	}
		
	function DDA_CreateBatchFileBtn::onAction(%this) {
		DEDDemoAdvanced.OutputBatchFile = %this.getValue();
	}			

 	function DEDDemoAdvanced_SetFPSSlider() {
		DEDDemoAdvanced.FPS = mfloor(DDA_OutputFPSSlider.getValue());
		
		DDA_OutputFPSText.setText("Frames Per Second = " @ DEDDemoAdvanced.FPS);
 	}
 	
 	function DEDDemoAdvanced_SetGammaSlider() {
		DEDDemoAdvanced.GammaCorrection = DDA_OutputGammaSlider.getValue();
		if (DEDDemoAdvanced.ShowCurrentGamma)
			videoSetGammaCorrection( DEDDemoAdvanced.GammaCorrection );
	}
	
	function DEDDemoAdvancedDefaultGamma() {
		DEDDemoAdvanced.GammaCorrection = $pref::OpenGL::gammaCorrection;
		DDA_OutputGammaSlider.setValue(DEDDemoAdvanced.GammaCorrection);
		if (DEDDemoAdvanced.ShowCurrentGamma)
			videoSetGammaCorrection( DEDDemoAdvanced.GammaCorrection );
	}

	function DEDDemoAdvancedOutputShowGammaBtn::onAction(%this) {
		DEDDemoAdvanced.ShowCurrentGamma = %this.getValue();

		if (%this.getValue)
			videoSetGammaCorrection( DEDDemoAdvanced.GammaCorrection );
		else
			videoSetGammaCorrection( $pref::OpenGL::gammaCorrection );
			
		DEDDemoAdvanced_SetGammaSlider();
	}
 	




//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Batch Conversion System
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvanced_LoadBatchConversionFile(%fileName) {
		if(isFile(%fileName)) {
			$DDATMP::BatchFileList = "";
			$DDATMP::BatchFileCount = 0;
			$DDATMP::BatchTimeList = "";
			exec(%fileName);
		} else
			echo("Batch Conversion File not found");
	}

	function DEDDemoAdvanced_AddFile(%file) {
		// filename = recordings/directory/file.rec
		$DDATMP::BatchFileList[$DDATMP::BatchFileCount] = %file;
		$DDATMP::BatchTimeList[$DDATMP::BatchFileCount] = "";
		$DDATMP::BatchFileCount++;
	}

	function DEDDemoAdvanced_ClearTimes() {
		$DDATMP::BatchTimeList[$DDATMP::BatchFileCount] = "";	
	}

	function DEDDemoAdvanced_AddTime(%start, %end) {
		// timelist is a list of times, start-finish: eg. "00:00 00:05 00:25 00:30" etc
		$DDATMP::BatchTimeList[$DDATMP::BatchFileCount] = $DDATMP::BatchTimeList[$DDATMP::BatchFileCount] @ %start @ " " @ %end @ " ";
	}

	function DEDDemoAdvanced_StartBatching() {
		$DDATMP::CurrentlyBatching = true;
		$DDATMP::CurrentBatchFile = 0;
		DEDDemoAdvanced.OutputtingScreenShots = true;

		DEDDemoAdvanced_StartNextDemoInBatch();
	}

	function DEDDemoAdvanced_GetNextTime() {
		%text = $DDATMP::BatchTimeList[$DDATMP::BatchFileCount];
		%val = getWordCount(%text);
		%upTo = $DDATMP::CurrentBatchTime;
		$DDATMP::CurrentBatchTime++;
		if (%upTo >= %val) 
			return -1;
		else 
			return (getWord(%text,%upTo));
	}

	function DEDDemoAdvanced_StartNextDemoInBatch() {
		$DDATMP::CurrentBatchTime = 0;
		%file = $DDATMP::BatchFileList[$DDATMP::CurrentBatchFile];

   		%val = DEDDemoAdvanced.CurrentDemoFile @ ".png";
		%valtwo = getSubStr(%val, 11, (strlen(%val) - 19));
		if (StrStr(%valtwo,"/") != -1) {
			%i = Strlen(%valtwo);
			while(%i > 0 && GetSubStr(%valtwo,%i,1) !$= "/") {
				%i--;
			}
		
			if (%i > 0) {
				%fileDir = "Sequenced Images/" @ GetSubStr(%valtwo,0,%i) @ "/";
				$DEDDemoAdvanced = new FileObject();
				$DEDDemoAdvanced.openForWrite(%fileDir);
				$DEDDemoAdvanced.close();
				$DEDDemoAdvanced.delete();
				$DEDDemoAdvanced = "";
			}	
		}

	
		if (DEDDemoAdvanced.OutputMuteSounds) {
			DEDDemoAdvanced.PreviousVolume = $pref::Audio::masterVolume;
			alxListenerf( AL_GAIN_LINEAR, 0 );
		}

		DEDDemoAdvanced.ScreenShotsName = "base/Sequenced Images/" @ %valtwo @ "";
		DEDDemoAdvanced.OutputStartMatch = DEDDemoAdvanced_GetNextTime();
		DEDDemoAdvanced.OutputFinishMatch = DEDDemoAdvanced_GetNextTime();
		DEDDemoAdvanced.OutputLock = false;
		
		%verLen = getDemoVersionLength(%file);
		DEDDemoAdvanced.CurrentDemoFile = %file;
		Canvas.pushDialog(DemoLoadProgressDlg);
   		
		if(playDemo(%file)) {
			alxEnableForceFeedback(false);
			resetGameState();
			Canvas.popDialog(DemoLoadProgressDlg);
			Canvas.popDialog(RecordingsDlg);   
			Canvas.setContent(PlayGui);
			loadDemoSettings();

			$DemoPlaybackIndex = 1;
			$DemoPlaybackLastIndex = 1;

			GlobalActionMap.bindCmd(keyboard, "escape", "", "DEDDemoAdvanced::StopBatchStuff();");

      			$DemoPlaybackProgress = 0;
      			$DemoPlaybackLength = getField(%verLen, 1);
	
      			if($DemoPlaybackLength == 0)
         			$DemoPlaybackLength = 60000;
      
	      		DemoPlayback_EndTime.setValue(msToMinSec($DemoPlaybackLength));
	
      			$DemoPlaybackProgress = 0;
	      		demoPlaybackUpdate(0);

      			updateDemoPlaybackStatus();
		} else
			MessageBoxOK("Playback Failed", "Demo playback failed for file '" @ %file @ "'.");

		Canvas.popDialog(DemoLoadProgressDlg);
	}

	function DEDDemoAdvanced::StopBatchStuff() {
		$DDATMP::Exit = true;
		stopDemoPlayback();
	}


//------------------------------------------------------------------------------------------
// Keybind wrappers
//------------------------------------------------------------------------------------------

	function DEDDemoAdvancedDeleteLastDemo(%val) {
		if (!%val) return;
		DEDDemoAdvanced.DeleteLastDemo();	
	}


	function DEDDemoAdvancedToggleOptions(%val) {
		if (!%val) return;
		DEDDemoAdvanced.ToggleOptions();	
	}
	
	function DEDDemoAdvancedDemoFaster(%val) {
		if (!%val) return;
		stepDemoPlaybackSpeed(1);
	}

	function DEDDemoAdvancedDemoSlower(%val) {
		if (!%val) return;
		stepDemoPlaybackSpeed(-1);
	}

	function DEDDemoAdvancedReplaceSnapshot(%val) {
		if (!%val) return;
		DEDDemoAdvanced.ReplaceSnapshot();
	}

	function DEDDemoAdvancedDemoDefault(%val) {
		if (!%val) return;
		SetDemoSpeed(1);
	}






//------------------------------------------------------------------------------------------
// DDA_PlaybackDlg GUI Functions
//------------------------------------------------------------------------------------------
	// Shows the DDA_PlaybackDlg gui.
	function DEDDemoAdvanced::ShowPlayBackHUD(%this) {
		DEDDemoAdvanced.SetHUDPosition(DDA_PlaybackDlg, DEDDemoAdvanced.HUDPosPlayBackHUD);
		DEDDemoAdvanced.PlayBackHUDCanvasID = Canvas.getContent();
		Canvas.getContent().add(DDA_PlaybackDlg);
		DEDDemoAdvanced.MouseShow();

		DDA_PlaybackDlg.Shown = true;
	}


	// Hide the DDA_PlaybackDlg gui.
	function DEDDemoAdvanced::HidePlayBackHUD(%this) {
		DEDDemoAdvanced.PlayBackHUDCanvasID.remove(DDA_PlaybackDlg);
		DDA_PlaybackDlg.Shown = false;
		DEDDemoAdvanced.MouseHide();
		canvas.repaint();
	}




//------------------------------------------------------------------------------------------
// Base Tribes 2 Function Overrides
//------------------------------------------------------------------------------------------
	function DispatchLaunchMode() {
		parent::DispatchLaunchMode();

		DEDDemoAdvanced.Setup();
		
		callback.add(onMissionEnd, "DEDDemoAdvancedGameOver");
		callback.add(DEDonGameOver, "DEDDemoAdvancedGameOver");
		callback.add(onMatchStart, "DEDDemoAdvancedMissionStart");
	}


	function DefaultGame::gameOver(%game) {
		parent::gameOver(%game);
		callback.trigger(DEDonGameOver);
	}


	// Toggles the PlayBackHUD menu on or off, showing and hiding it as necessary.
	function toggleDemoPlaybackHud() {
		if (!DDA_PlaybackDlg.Shown) {
			DEDDemoAdvanced.ShowPlayBackHUD();
		} else {
			DEDDemoAdvanced.HidePlayBackHUD();
		}			

	}




	// When the OptionsDlg wakes, set the keybinds for the script.
	function OptionsDlg::onWake(%this) {
		// If the keybinds haven't already been set.
		if (!DEDDemoAdvanced.BoundKeys) {
			$RemapName[$RemapCount] = "Demo Options";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedToggleOptions";
			$RemapCount++;

			$RemapName[$RemapCount] = "Toggle Playback Menu";
			$RemapCmd[$RemapCount]  = "toggleDemoPlaybackHud";
			$RemapCount++;

			$RemapName[$RemapCount] = "Stop Demo";
			$RemapCmd[$RemapCount]  = "stopDemoPlayback";
			$RemapCount++;

			$RemapName[$RemapCount] = "Default Demo Speed";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedDemoDefault";
			$RemapCount++;

			$RemapName[$RemapCount] = "Speed up Demo";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedDemoFaster";
			$RemapCount++;

			$RemapName[$RemapCount] = "Slow down Demo";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedDemoSlower";
			$RemapCount++;

			$RemapName[$RemapCount] = "Pause Demo";
			$RemapCmd[$RemapCount]  = "toggleDemoPause";
			$RemapCount++;

			$RemapName[$RemapCount] = "Take Demo Snapshot";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedReplaceSnapshot";
			$RemapCount++;

			$RemapName[$RemapCount] = "Delete Last Demo";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedDeleteLastDemo";
			$RemapCount++;
			
			DEDDemoAdvanced.BoundKeys = true;
		}
	
		parent::onWake(%this);
	}



};




// Create the DEDDemoAdvanced object if it does not already exist.
if(!isObject(DEDDemoAdvanced)) {
	new ScriptObject(DEDDemoAdvanced) {
		class = DEDDemoAdvanced;
	};
}

// Activate the DEDDemoAdvanced package.
activatePackage(DEDDemoAdvanced);








//---------------------------------------------------------------------
// Profiles
//---------------------------------------------------------------------

new GuiControlProfile ("DEDDemoAdvancedBigWhiteText" ) {
	fontType = "Univers Condensed Bold";
	fontSize = 28;
	fontColor = "255 255 255";
	justify = "left";
	autoSizeWidth = true;
	autoSizeHeight = true;
};

new GuiControlProfile ("UpDirectoryButtonProfile") {
	bitmap = "gui/DDA_UpDirectoryButton";
};

new GuiControlProfile ("MakeDirectoryButtonProfile") {
	bitmap = "gui/DDA_MakeDirectoryButton";
};

new GuiControlProfile ("TakeSnapshotButtonProfile") {
	bitmap = "gui/DDA_TakeSnapshotButton";
};

new GuiControlProfile ("MarkStartButtonProfile") {
	bitmap = "gui/DDA_MarkStartButton";
};

new GuiControlProfile ("DDABigLoadingTextProfile") {
	fontType = $ShellHeaderFont;
	fontSize = 28;
	fontColor = "255 255 255";
	justify = "left";
	autoSizeWidth = true;
	autoSizeHeight = true;
};

new GuiControlProfile("DDABackProfile") {
	opaque = true;
	fillColor = "0 0 0 0";
};


new GuiControlProfile ("DDATextProfile") {
	fontType = $ShellLabelFont;
	fontSize = 12;
	fontColor = "0 0 0";
	autoSizeWidth = false;
	autoSizeHeight = false;
};


new GuiControlProfile ("DDAAltTextProfile") {
	fontType = $ShellLabelFont;
	fontSize = 12;
	fontColor   = "60 180 180";
	autoSizeWidth = false;
	autoSizeHeight = false;
};


new GuiControlProfile("DDASlowButtonProfile") {
	bitmap = "gui/DDA_Slow";
};


new GuiControlProfile("DDAPlayButtonProfile") {
	bitmap = "gui/DDA_Play";
};


new GuiControlProfile("DDAPausedButtonProfile") {
	bitmap = "gui/DDA_Paused";
};


new GuiControlProfile("DDAFastButtonProfile") {
	bitmap = "gui/DDA_Fast";
};


new GuiControlProfile("DDACloseButtonProfile") {
	bitmap = "gui/DDA_Close";
};


new GuiControlProfile("DDAPrefsButtonProfile") {
	bitmap = "gui/DDA_Prefs";
};


new GuiControlProfile("DDABitmapProfile") {
	border = true;
	borderColor = "60 180 180 255";
};

new GuiControlProfile("DDAShellServerBrowserProfile") {
	fontType = $ShellLabelFont;
	fontSize = 12;
	fontColor   = "60 180 180";
	fontColorHL = "6 245 215";
	fontColorNA = "128 128 128";
	fontColorSEL = "25 68 56";
	fontColors[4] = "20 167 93";     // Mod base color
	fontColors[5] = "40 217 113";    // Mod rollover color
	fontColors[6] = "5 60 30";       // Mod selected color
	fontColors[7] = "108 108 108";   // Differing build base color       
	fontColors[8] = "168 168 168";   // Differing build rollover color
	fontColors[9] = "58 58 58";      // Differing build selected color
	bitmapBase = "gui/shll_scroll";
	autoSizeWidth = false;
	autoSizeHeight = false;
};


new GuiControlProfile("DDAShellPopupProfile") {
	fontType = $ShellLabelFont;
	fontSize = 12;
	fontColor = "8 19 6";
	fontColorHL = "25 68 56";
	fontColorNA = "5 5 5";
	fontColorSEL = "8 19 6";
	fixedExtent = true;
	justify = "center";
	bitmapBase = "gui/shll_scroll";
};


new GuiControlProfile ("DDANewScrollCtrlProfile") {
	fontType = $ShellHeaderFont;
	fontSize = 12;
	fontColor = "5 5 5";

	opaque = true;
	fillColor = "0 0 0 0";

	bitmapBase = "gui/shll_scroll";
};


new GuiControlProfile("DDAShellDlgPaneProfile") {
	fontType = $ShellHeaderFont;
	fontSize = 12;
	fontColor = "5 5 5";
	opaque = true;
	autoSizeWidth = false;
	autoSizeHeight = false;
	bitmapBase = "gui/dlg";
};


new GuiControlProfile ("DDAShellProgressBarProfile") {
	opaque = false;
	fillColor = "255 0 0 100";
	border = true;
	borderColor   = "255 0 0";
};



//------------------------------------------------------------------------------------------	
// DEDDemoAdvancedConfigGUI declaration.
//------------------------------------------------------------------------------------------
// If the DEDDemoAdvancedConfigGUI object already exists, delete it.
if (isObject(DEDDemoAdvancedConfigGUI)) {
	DEDDemoAdvancedConfigGUI.delete();
}


// Create the new DEDDemoAdvancedConfigGUI object.
new GuiControl(DEDDemoAdvancedConfigGUI) {
	profile = "DDABackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "640 480";
	visible = "1";
	pane = "Naming";

	new ShellPaneCtrl(DDA_MainOptionsWindow) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "640 480";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "ADVANCED DEMO OPTIONS";
		maxLength = "255";
		noTitleBar = "0";
		
		// The scroll window that houses the options.  
		new ShellScrollCtrl(DEDDemoAdvanced_Scroll) {
			profile = "DDANewScrollCtrlProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "13 22";
			extent = "614 446";
			minExtent = "0 0";
			visible = "1";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "alwaysoff";
			vScrollBar = "alwaysoff";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "0 3";
			fieldBase = "gui/shll_field";

			// The tab group.
			new ShellTabGroupCtrl(DDA_TabView) {
				profile = "TabGroupProfile";
				horizSizing = "width";
				vertSizing = "top";
				position = "0 0";
				extent = "604 436";
				minExtent = "0 0";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				glowOffset = "7";
				tabSpacing = "2";
				maxTabWidth = "200";
				stretchToFit = "0";
			};

			// The Naming pane.
			new ShellPaneCtrl(DDA_NamingPane) {
				profile = "ShellDlgPaneProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 30";
				extent = "604 406";
				minExtent = "48 92";
				visible = "1";
				helpTag = "0";
				text = "Demo Naming Conventions";
				maxLength = "255";
				noTitleBar = "0";

				// Left arrow graphic.
				new GuiBitmapCtrl(DEDDemoAdvancedArrowLeft) {
					profile = "GuiDefaultProfile";
					horizSizing = "left";
					vertSizing = "bottom";
					position = "141 63";
					extent = "12 170";
					minExtent = "10 0";
					visible = "1";
					bitmap = "gui/DDA_ArrowLeft.png";
      				};

				// Right arrow graphic.
				new GuiBitmapCtrl(DEDDemoAdvancedArrowRight) {
					profile = "GuiDefaultProfile";
					horizSizing = "left";
					vertSizing = "bottom";
					position = "447 63";
					extent = "12 170";
					minExtent = "10 0";
					visible = "1";
					bitmap = "gui/DDA_ArrowRight.png";
	      			};

			// Directory heading text.
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "60 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Directory";
				longTextBuffer = "0";
				maxLength = "255";
			};

			// Text prefix directory toggle.
			new ShellToggleButton(DEDDemoAdvancedTextPrefixDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 50";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "TEXT PREFIX";
				maxLength = "255";
			};		
		
			new ShellToggleButton(DEDDemoAdvancedPlayerNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 75";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "PLAYER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 100";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SERVER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerModNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 125";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SERVER MOD";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedMissionNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 150";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "MISSION NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedGameTypeDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 175";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "GAME TYPE";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTeamNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 200";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "TEAM NAME";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "495 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Filename:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTextPrefixBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 50";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "TEXT PREFIX";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedPlayerNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 75";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "PLAYER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 100";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SERVER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerModNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 125";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SERVER MOD";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedMissionNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 150";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "MISSION NAME";
				maxLength = "255";
			};
		
			new ShellToggleButton(DEDDemoAdvancedGameTypeBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 175";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "GAME TYPE";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedTeamNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 200";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "TEAM NAME";
				maxLength = "255";
			};
			
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Example Directory and Filename:";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
       			new ShellScrollCtrl(DEDDemoAdvanced_DemoNameScroll) {
       				profile = "NewScrollCtrlProfile";
       				horizSizing = "width";
       				vertSizing = "height";
       				position = "145 50";
       				extent = "310 155";
       				minExtent = "310 155";
       				visible = "1";
	                        hideCursor = "0";
        	                bypassHideCursor = "0";
        			helpTag = "0";
        			willFirstRespond = "1";
        			hScrollBar = "dynamic";
        			vScrollBar = "dynamic";
        			constantThumbHeight = "0";
        			defaultLineHeight = "15";
        			childMargin = "0 3";
        			fieldBase = "gui/shll_field";

        			new GuiScrollContentCtrl() {
        				profile = "GuiDefaultProfile";
        				horizSizing = "width";
        				vertSizing = "bottom";
        				position = "4 7";
        				extent = "310 155";
        				minExtent = "310 155";
        				visible = "1";
                            		hideCursor = "0";
					bypassHideCursor = "0";
        				helpTag = "0";

        				new GuiMLTextCtrl(DEDDemoAdvanced_FileNameText) {
        					profile = "ShellAltTextProfile";
        					horizSizing = "width";
        					vertSizing = "bottom";
        					position = "0 0";
        					extent = "310 155";
        					minExtent = "310 155";
        					visible = "1";
                                		hideCursor = "0";
                                		bypassHideCursor = "0";
        					helpTag = "0";
        					lineSpacing = "2";
        					allowColorChars = "1";
        					maxChars = "-1";
        				};
        			};
        		};
        		
			new ShellTextEditCtrl(DEDDemoAdvancedTextPrefixDirText_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "145 200";
				extent = "140 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "DEDDemoAdvanced.TextPrefixDirText";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				glowOffset = "9 9";
			};
			
			new ShellTextEditCtrl(DEDDemoAdvancedTextPrefixText_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "315 200";
				extent = "140 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "DEDDemoAdvanced.TextPrefixText";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				glowOffset = "9 9";
			};
			
			new ShellTextEditCtrl(DEDDemoAdvancedTextSeparator_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 200";
				extent = "50 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "DEDDemoAdvanced.TextSeparator";
				maxLength = "3";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				glowOffset = "9 9";
			};
			
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 232";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Filename Text Separator";
				longTextBuffer = "0";
				maxLength = "255";
			};

		};

		new ShellPaneCtrl(DDA_RecordingPane) {
			profile = "ShellDlgPaneProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 30";
				extent = "604 406";
				minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "Recording Features";
			maxLength = "255";
			noTitleBar = "0";

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 33";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Icon";
				longTextBuffer = "0";
				maxLength = "255";
			};
		
			new ShellToggleButton(DEDDemoAdvancedShowRecordBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 50";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SHOW RECORDING ICON";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedShowRecordBlinkBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 75";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "FLASH RECORDING ICON";
				maxLength = "255";
			};

			new ShellPopupMenu(DEDDemoAdvancedSelectStartRecordBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "200 46";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Image";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "210 78";
				extent = "120 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Size:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellSliderCtrl(DEDDemoAdvanced_RecordingHudSize) {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "235 75";
				extent = "140 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "value";
				altCommand = "DEDDemoAdvanced.SetRecordingHudSize();";
				helpTag = "0";
				range = "0.2 3.0";
				ticks = "0.0";
				value = "1.6";
				usePlusMinus = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "380 33";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Preview Image:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new GuiBitmapCtrl(DEDDemoAdvancedOnIcon) {
				profile = "GuiDefaultProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "385 56";
				extent = "75 50";
				minExtent = "10 0";
				visible = "1";
				bitmap = "gui/DDA_Basic_On.png";
	      		};	


			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 115";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Automated Recording Features";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedPromptBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "righ";
				vertSizing = "bottom";
				position = "220 132";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "PROMPT FOR FILENAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedAutomaticSafetyModeBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "righ";
				vertSizing = "bottom";
				position = "220 157";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "AUTOMATIC SAFETY MODE";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedRecordOnMapStartBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 132";
				extent = "190 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "RECORD FROM MAP START";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedStopAtMapEndBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 157";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "STOP AT MAP END";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedAlwaysRecordTournamentsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 157";
				extent = "190 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "ALWAYS RECORD TOURNAMENTS";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedShowScoresBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 132";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "SHOW SCORES";
				maxLength = "255";
			};


			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 191";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Snapshot Features";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTakeSnapshotsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 208";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "AUTOMATIC SNAPSHOTS";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "200 212";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "AT:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellPopupMenu(DEDDemoAdvancedSelectTakeSnapshotsBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "217 202";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Snapshot At";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new ShellToggleButton(DEDDemoAdvancedNoSnapshotHUDsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 208";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "NO HUDS IN SNAPSHOT";
				maxLength = "255";
			};
	
		};

		new ShellPaneCtrl(DDA_AudioPane) {
			profile = "ShellDlgPaneProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 30";
				extent = "604 406";
				minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "Audio Alerts";
			maxLength = "255";
			noTitleBar = "0";

			new ShellToggleButton(DEDDemoAdvancedEnableAudioAlertsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 30";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "value";
				helpTag = "0";
				text = "ENABLE AUDIO ALERTS";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 58";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Start";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestStartSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 55";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound(DEDDemoAdvanced.StartSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectStartSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 49";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 83";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Stop";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestStopSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 80";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound(DEDDemoAdvanced.StopSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectStopSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 74";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 108";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Deleted";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestDeleteSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 105";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound(DEDDemoAdvanced.DeleteSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectDeleteSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 99";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 133";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Safety";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestSafetySoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 130";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound(DEDDemoAdvanced.SafetySound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectSafetySoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 124";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
		};
		
		new ShellBitmapButton(DEDDemoAdvancedConfigClose) {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 380";
			extent = "180 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvanced.ToggleOptions();DEDDemoAdvanced.SavePrefs();";
			accelerator = "escape";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};


	};
};
};














//---------------------------------------------------------------------
// Demo Playback Dialog
//---------------------------------------------------------------------
if (isObject(DDA_PlaybackDlg)) {
	DDA_PlaybackDlg.delete();
}


// Create the new DDA_PlaybackDlg object.
new GuiControl(DDA_PlaybackDlg) {
	profile = "DDABackProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "350 29";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	// Main graphic and body of menu.
	new GuiBitmapCtrl(DDA_PlaybackMain) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "350 29";
		minExtent = "10 0";
		visible = "1";
		bitmap = "gui/DDA_Main.png";

		// The progress bar for the demo
		new GuiProgressCtrl(DDA_PlaybackProgressBar) {
			profile = "DDAShellProgressBarProfile";
			horizSizing = "right";
			vertSizing = "center";
			position = "5 8";
			extent = "160 20";
			minExtent = "32 15";
			visible = "1";
			hideCursor = "0";
			variable = "$DemoPlaybackProgress";
			bypassHideCursor = "0";
			helpTag = "0";
			glowOffset = "9 9";
		};

		new GuiBitmapCtrl(DDA_Playback_ProgressOverlay) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "165 29";
			minExtent = "10 0";
			visible = "1";
			bitmap = "gui/DDA_Main_ProgressOverlay.png";
		};

		
		// Track name and length.
		new GuiTextCtrl(DemoPlayback_StartTime) {
			profile = "DDATextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "17 8";
			extent = "300 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		// Current time elapsed.
		new GuiTextCtrl(DemoPlayback_EndTime) {
			profile = "DDATextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "130 8";
			extent = "150 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		// Current time elapsed.
		new GuiTextCtrl(DemoPlayback_CurTime) {
			profile = "DDATextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "76 8";
			extent = "150 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		// Current speed.
		new GuiTextCtrl(DEDDemoAdvanced_CurSpeed) {
			profile = "DDATextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "206 8";
			extent = "150 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "1 X";
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		// Mouse event handler for the DEDDemoAdvancedGui object.
		new GuiMouseEventCtrl(DDA_PlaybackMainMouseEvent) {
			profile = "DefaultProfile";
			position = "0 0";
			extent = "350 29";
			vertSizing = "top";
			horizSizing = "left";
			visible = "true";
		};
      	};

	// Slow down playback button.
	new ShellBitmapButton(DDA_PlaybackSlowBtn) {
		profile = "DDASlowButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "163 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "stepDemoPlaybackSpeed(-1);";
		helpTag = "0";
		simpleStyle = "1";
	};

	// Speed up button.
	new ShellBitmapButton(DDA_PlaybackFastBtn) {
		profile = "DDAFastButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "263 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "stepDemoPlaybackSpeed(1);";
		helpTag = "0";
		simpleStyle = "1";
	};
	
	// Play button.
	new ShellBitmapButton(DDA_PlaybackPlayBtn) {
		profile = "DDAPlayButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "283 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "toggleDemoPause();";
		helpTag = "0";
		simpleStyle = "1";
	};

	// Paused button.
	new ShellBitmapButton(DDA_PlaybackPausedBtn) {
		profile = "DDAPausedButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "283 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "0";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "toggleDemoPause();";
		helpTag = "0";
		simpleStyle = "1";
	};

	// Toggle preferences menu button.
	new ShellBitmapButton(DDA_PlaybackToggleOptionsBtn) {
		profile = "DDAPrefsButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "303 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "DEDDemoAdvanced.ToggleOptions();";
		helpTag = "0";
		simpleStyle = "1";
	};

	// Close Playback menu button.
	new ShellBitmapButton(DDA_PlaybackCloseBtn) {
		profile = "DDACloseButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "323 1";
		extent = "24 24";
		minExtent = "24 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "toggleDemoPlaybackHud();";
		helpTag = "0";
		simpleStyle = "1";
	};
};













//---------------------------------------------------------------------
// Recordings GUI
//---------------------------------------------------------------------

if (isObject(RecordingsDlg)) {
	RecordingsDlg.delete();
}

new GuiControl(RecordingsDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "800 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 320";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "SELECT RECORDING";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellPopupMenu(DEDDemoAdvancedDirectoryDropDown) {
			profile = "DDAShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "14 24";
			extent = "370 38";
			minExtent = "100 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Directory";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new ShellBitmapButton(DEDDemoAdvancedUpDirectoryBtn) {
			profile = "UpDirectoryButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "375 30";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvanced.PreviousDirectory();";
			helpTag = "0";
			simpleStyle = "1";
		};
		
		new ShellBitmapButton(DEDDemoAdvancedMakeDirectoryBtn) {
			profile = "MakeDirectoryButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "395 30";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvanced.MakeDirectory();";
			helpTag = "0";
			simpleStyle = "1";
		};

		new GuiBitmapCtrl(DEDDemoAdvancedScreenPreview) {
			profile = "DDABitmapProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "420 30";
			extent = "200 150";
			minExtent = "0 0";
			visible = "1";
			bitmap = "snapshots/No_Screen.png";
	      	};	

		new GuiBitmapCtrl(DEDDemoAdvancedScreenMagnify) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "600 160";
			extent = "15 15";
			minExtent = "0 0";
			visible = "0";
			bitmap = "gui/DDA_Magnify.png";
			command = "DEDDemoAdvancedShowFullSnapShot();";
	      	};

		new ShellFancyArrayScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "18 54";
			extent = "400 236";
			minExtent = "32 32";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fixedHorizontal = "1";
			vertSpacerBitmap = "gui/shll_vertspacer";
			horzSpacerBitmap = "gui/shll_horzspacer";

			new ShellFancyTextList(RecordingsDlgList) {
				profile = "DDAShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "380 232";
				minExtent = "8 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				startScrollRegion = "3 0";
				headerBitmap = "gui/server_tabs";
				sortArrowBitmap = "gui/shll_sortarrow";
				fieldBase = "gui/shll_field";
				barBase = "gui/shll_bar";
				glowOffset = "4";
				rowHeight = "14";
				drawSeparators = "0";
				headerSort = "1";
				allowReposition = "1";
				noSelect = "0";
				allowColorChars = "1";
				command = "DEDDemoAdvancedUpdateDetails();";
		            	altCommand = "startSelectedDemo();";
			};
		};
		
		new ShellBitmapButton(PR_StartDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "410 180";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "StartSelectedDemo();";
			helpTag = "0";
			text = "PLAY";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DDA_OutputDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "512 180";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.pushdialog(OutputSelectedDemoDlg);";
			helpTag = "0";
			text = "OUTPUT";
			simpleStyle = "0";
		};
		
		new ShellBitmapButton(PR_RenameDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "410 208";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "RenameSelectedDemo();";
			helpTag = "0";
			text = "RENAME";
			simpleStyle = "0";
		};
		
		new ShellBitmapButton(PR_DeleteDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "512 208";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvanced.DeleteSelectedDemo();";
			helpTag = "0";
			text = "DELETE";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DDA_OptionsBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "410 236";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvanced.ToggleOptions();";
			helpTag = "0";
			text = "OPTIONS";
			simpleStyle = "0";
		};

		new ShellBitmapButton(PR_CancelBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "512 236";
			extent = "115 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popDialog(RecordingsDlg);DEDDemoAdvanced.SavePrefs();";
			accelerator = "escape";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
		};
		
		new GuiTextCtrl(DEDDemoAdvancedFilenameDisplay) {
			profile = "DDAAltTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "24 288";
			extent = "370 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filename:";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiBitmapCtrl(DEDDemoAdvancedMiniTitle) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "420 272";
			extent = "200 27";
			minExtent = "0 0";
			visible = "1";
			bitmap = "texticons/DDA_TitleGraphic.png";
	      	};	
	};
};















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Make Directory GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedMakeDirectoryDlg)) {
	DEDDemoAdvancedMakeDirectoryDlg.delete();
}

new GuiControl(DEDDemoAdvancedMakeDirectoryDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "170 186";
		extent = "300 146";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Create Directory...";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(DEDDemoAdvancedMakeDirectory_Edit) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "71 39";
			extent = "209 39";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 47";
			extent = "48 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Directory:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedMakeDirectoryDlg); doMakeDirectory();";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "154 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedMakeDirectoryDlg);";
		};
	};
};


















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Filename prompt GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedFilenamePromptDlg)) {
	DEDDemoAdvancedFilenamePromptDlg.delete();
}

new GuiControl(DEDDemoAdvancedFilenamePromptDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "170 186";
		extent = "300 146";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Change Filename";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(DEDDemoAdvancedFilenamePromptDlg_Edit) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "71 39";
			extent = "209 39";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 47";
			extent = "48 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filename:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
         		command = "DEDDemoAdvanced.TempDemoFileName = DEDDemoAdvancedFilenamePromptDlg_Edit.getValue();Canvas.popDialog(DEDDemoAdvancedFilenamePromptDlg);beginDemoRecordNextBit();";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "154 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedFilenamePromptDlg);beginDemoRecordNextBit();";
		};
	};
};








//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Fullscreen snapshot GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedFullScreenPicture)) {
	DEDDemoAdvancedFullScreenPicture.delete();
}

new GuiControl(DEDDemoAdvancedFullScreenPicture) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "1024 768";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new GuiBitmapCtrl(DEDDemoAdvancedFullScreenPictureView) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "1024 768";
		minExtent = "0 0";
		visible = "1";
		bitmap = "snapshots/No_Screen.png";
		
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popdialog(DEDDemoAdvancedFullScreenPicture);";
			accelerator = "escape";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};
      	};
};












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Load progress GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DemoLoadProgressDlg)) {
	DemoLoadProgressDlg.delete();
}

new GuiControl(DemoLoadProgressDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = firstWord($pref::Video::resolution) @ " " @ getWord($pref::Video::resolution, 1);
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new GuiBitmapCtrl(DEDDemoAdvancedLoadingPicture) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = firstWord($pref::Video::resolution) @ " " @ getWord($pref::Video::resolution, 1);
		minExtent = "0 0";
		visible = "1";
		bitmap = "";

		new GuiTextCtrl(DDA_BigLoadingTextProfile) {
			profile = "DDABigLoadingTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = (mfloor(getword(DEDDemoAdvancedLoadingPicture.extent, 0)/2)) @ " " @ (getword(DEDDemoAdvancedLoadingPicture.extent, 1));
			extent = "100 40";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Loading";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiBitmapCtrl(DEDDemoAdvancedLoadingName) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "0 0";
			extent = "600 80";
			minExtent = "10 0";
			visible = "1";
			bitmap = "texticons/DDA_TitleGraphic.png";
	      	};
		
		new GuiProgressCtrl(DemoLoadProgressCtrl) {
			profile = "ShellProgressBarProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "5 733";
			extent = (getword(DEDDemoAdvancedLoadingPicture.extent, 0)-10) @ " 30";
			minExtent = "32 15";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			glowOffset = "9 9";
		};
      	};
};





















//------------------------------------------------------------------------------------------	
// OutputSelectedDemoDlg declaration 
//------------------------------------------------------------------------------------------
// If the OutputSelectedDemoDlg object already exists, delete it.
if (isObject(OutputSelectedDemoDlg)) {
	OutputSelectedDemoDlg.delete();
}


// Create the new OutputSelectedDemoDlg object.
new GuiControl(OutputSelectedDemoDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(DDA_SequencedImagesMain) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 325";
		minExtent = "16 18";
		visible = "1";
		helpTag = "0";
		text = "OUTPUT IMAGE SEQUENCE";
		maxLength = "255";
		noTitleBar = "0";

		new ShellBitmapButton(DDA_OutputAddToList) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 107";
			extent = "200 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedAddOutputTimeToList();";
			helpTag = "0";
			text = "ADD TIME TO LIST";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DDA_OutputOutput) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "220 270";
			extent = "200 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedStartOutputtingScreenShots();";
			helpTag = "0";
			text = "OUTPUT";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DDA_OutputExit) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "420 270";
			extent = "200 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popdialog(OutputSelectedDemoDlg);";
			helpTag = "0";
			text = "EXIT";
			simpleStyle = "0";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "23 43";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Start Time";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "97 25";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Minutes";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellPopupMenu(DDA_OutputStartTimeMinuteDropDown) {
			profile = "ShellPopupProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "78 35";
			extent = "80 30";
			minExtent = "80 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "169 25";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Seconds";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellPopupMenu(DDA_OutputStartTimeSecondDropDown) {
			profile = "ShellPopupProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "150 35";
			extent = "80 30";
			minExtent = "80 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "23 83";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Finish Time";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "97 65";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Minutes";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellPopupMenu(DDA_OutputFinishTimeMinuteDropDown) {
			profile = "ShellPopupProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "78 75";
			extent = "80 30";
			minExtent = "80 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "169 65";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Seconds";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellPopupMenu(DDA_OutputFinishTimeSecondDropDown) {
			profile = "ShellPopupProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "150 75";
			extent = "80 30";
			minExtent = "80 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};


		new GuiTextCtrl(DDA_OutputFPSText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "55 152";
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Frames Per Second = 1";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputFPSSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "25 170";
			extent = "190 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetFPSSlider();";
			helpTag = "0";
			range = "1.0 100.0";
			ticks = "1.0";
			value = "0.0";
			usePlusMinus = "1";
		};

		new GuiTextCtrl(DDA_OutputGammaText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "55 202";
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Output Gamma Correction";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputGammaSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "25 220";
			extent = "190 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetGammaSlider();";
			helpTag = "0";
			range = "0.000000 1.000000";
			ticks = "1000";
			value = "0.385965";
			usePlusMinus = "1";
		};

		new ShellToggleButton(DEDDemoAdvancedOutputShowGammaBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 245";
			extent = "100 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW GAMMA";
			maxLength = "255";
		};
		
		new ShellBitmapButton(DEDDemoAdvancedDefaultGammaBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "115 240";
			extent = "110 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedDefaultGamma();";
			helpTag = "0";
			text = "STANDARD";
			simpleStyle = "0";
		};

		new ShellToggleButton(DDA_CreateBatchFileBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 275";
			extent = "195 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "GENERATE BATCH FILE";
			maxLength = "255";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 25";
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Outputting Settings";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputPanoramaViewBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 40";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "PANORAMA VIEW";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputShowClientHUDSBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 65";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW CLIENT HUDS";
			maxLength = "255";
		};
	
		new ShellToggleButton(DDA_OutputShowTargetsBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 90";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW TARGETS";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputShowPotentialTaskBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 115";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW POTENTIAL TASKS";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputShowAssignedTaskBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 140";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW ASSIGNED TASKS";
			maxLength = "255";
		};
			
		new ShellToggleButton(DDA_OutputShowClientWaypointBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 165";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW CLIENT WAYPOINTS";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputShowMissionWaypointBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 190";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW MISSION WAYPOINTS";
			maxLength = "255";
		};

		new ShellToggleButton(DDA_OutputShowBeaconsBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 215";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "SHOW BEACONS";
			maxLength = "255";
		};


		new ShellToggleButton(DEDDemoAdvancedOutputMuteSoundsBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "230 240";
			extent = "170 30";
			minExtent = "26 27";
			visible = "1";
			variable = "value";
			helpTag = "0";
			text = "MUTE OUTPUT SOUNDS";
			maxLength = "255";
		};

		new ShellFancyArrayScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "405 35";
			extent = "210 236";
			minExtent = "32 32";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fixedHorizontal = "1";
			vertSpacerBitmap = "gui/shll_vertspacer";
			horzSpacerBitmap = "gui/shll_horzspacer";

			new ShellFancyTextList(DDABatchList) {
				profile = "DDAShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "380 232";
				minExtent = "8 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				startScrollRegion = "3 0";
				headerBitmap = "gui/server_tabs";
				sortArrowBitmap = "gui/shll_sortarrow";
				fieldBase = "gui/shll_field";
				barBase = "gui/shll_bar";
				glowOffset = "4";
				rowHeight = "14";
				drawSeparators = "0";
				headerSort = "1";
				allowReposition = "1";
				noSelect = "0";
				allowColorChars = "1";
				command = "";
		            	altCommand = "";
			};
		};





	};
};













//------------------------------------------------------------------------------------------	
// DEDDemoAdvancedRecordingHud declaration 
//------------------------------------------------------------------------------------------
// If the DEDDemoAdvancedRecordingHud object already exists, delete it.
if (isObject(DEDDemoAdvancedRecordingHud)) {
	DEDDemoAdvancedRecordingHud.delete();
}


// Create the new DEDDemoAdvancedRecordingHud object.
new GuiControl(DEDDemoAdvancedRecordingHud) {
	profile = "DDABackProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "42 25";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	// The bitmap image to display.
	new GuiBitmapCtrl(DEDDemoAdvancedRecordingHudBitmap) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "42 25";
		minExtent = "0 0";
		visible = "1";
		bitmap = "gui/DDA_Basic_On";
	
		// Mouse event handler for the DEDDemoAdvancedRecordingHud object.
		new GuiMouseEventCtrl(DEDDemoAdvancedRecordingHudEvent) {
			profile = "DefaultProfile";
			position = "0 0";
			extent = "42 25";
			vertSizing = "top";
			horizSizing = "left";
			visible = "true";
		};
	};
};
